/*
   Program..: DCPS.CH
   Author...: Roger Donnay
   Notice...: (c) DONNAY Software Designs 1987-2005
   Date.....: Mar 10, 2015
   Notes....: Special Printer Dialog commands for Pscript / eXpress++
*/

#xcommand DCPS BEGINDOC [<opt,...>] => DCPS ON [<opt>]

#command DCPS ON [<cPrinterName:NAME,PRINTERNAME><pname>] ;
                 [TITLE <cTitle>] ;
                 [ORIENTATION <nOrientation>]   ;
                 [COPIES <nCopies>] ;
                 [PAGESIZE <nPageSize>] ;
                 [DUPLEX <nDuplex>] ;
                 [PAPERBIN <nPaperBin>] ;
                 [FONT <cFont>] ;
                 [UNITS <nUnits>] ;
                 [TO <nError>] ;
                 [<a:ACROBAT>] [_ACROBAT <_a>] ;
                 [<x:XPSWRITER>] [_XPSWRITER <_x>] ;
                 [<p:PREVIEW>] [_PREVIEW <_p>] ;
  => ;
   [<nError> :=] DC_PSBeginDoc( <cPrinterName>,<cTitle>,<nOrientation>,<nCopies>,;
                                <nPageSize>,<nDuplex>,<nPaperBin>,<cFont>,;
                                <nUnits>, <.a.> [.OR. <_a>], <.x.> [.OR. <_x>], ;
                                <.p.> [.OR. <_p>] )

#command DCPS ENDDOC => DC_PsEndDoc()
#command DCPS OFF => DC_PsEndDoc()

#xcommand DCPS SAY <uText> [<opt,...>] => @ nil, nil DCPS SAY <uText> [<opt>]

#command @ <nRow>, <nCol> DCPS SAY <uText>                               ;
                   [PICTURE <cPict>]                                     ;
                   [<align:ALIGN,JUSTIFY> <nAlign>]                      ;
                   [FONT <cFont>]                                        ;
                   [COLOR <nFG>[,<nBG>]]                                 ;
                   [ANGLE <nAngle>]                                      ;
                   [POINT <nPoint>]                                      ;
                   [STYLE <nStyle>]                                      ;
  =>                                                                     ;
   DC_PsTextOut( <nRow>, <nCol>, <uText>, <cPict>, <nAlign>,             ;
                 <cFont>, <nFG>, <nBG>, <nAngle>, <nPoint>, <nStyle> )

#command @ <nTop>, <nLeft>, <nBottom>, <nRight> DCPS TEXTBOX <cText>     ;
                   [FONT <cFont>]                                        ;
                   [<align:ALIGN,JUSTIFY> <nAlign>]                      ;
                   [COLOR <nFG>[,<nBG>]]                                 ;
                   [THICKNESS <nThick>]                                  ;
                   [POINT <nPoint>]                                      ;
                   [STYLE <nStyle>]                                      ;
  =>                                                                     ;
   DC_PsTextBox( <nTop>, <nLeft>, <nBottom>, <nRight>, <cText>,          ;
                 <nAlign>, <cFont>, <nFG>, <nBG>, <nThick>, <nPoint>, ;
                 <nStyle> )


#command DCPS FONT <cFont> [COLOR <nFG> [,<nBG>]]  ;
  =>  ;
   DC_PsSetFont( <cFont>, <nFG>, <nBG> )

#command DCPS NEWPAGE => psNewPage()

#command @ <nTop>, <nLeft>, <nBottom>, <nRight> DCPS LINE ;
          [WIDTH <nThick>] ;
          [THICKNESS <nThick>] ;
          [COLOR <nColor>] ;
  =>  ;
  PsLine( <nTop>, <nLeft>, <nBottom>, <nRight>, <nThick>, DC_Color2PS(<nColor>)\[1] )

#command @ <nTop>, <nLeft>, <nBottom>, <nRight> DCPS FRAME ;
          [THICKNESS <nThick>] ;
          [WIDTH <nThick>] ;
          [BORDERCOLOR <nBorderColor>] ;
          [FILLCOLOR <nFillColor>] ;
          [PATTERN <nPattern>] ;
          [RADIUS <nRadius>] ;
  =>  ;
  PsFrame( <nTop>, <nLeft>, <nBottom>, <nRight>, <nThick>, ;
          DC_Color2PS(<nBorderColor>)\[1], DC_Color2PS(<nFillColor>)\[1], ;
          <nPattern>, <nRadius> )

#command @ <nTop>, <nLeft>, <nBottom>, <nRight> DCPS BITMAP <cBitmap> ;
           [TRANSCOLOR <nTransColor>] [<k:KEEPRATIO>]  ;
  => ;
  PsBitmap( <nTop>, <nLeft>, <nBottom>, <nRight>, <cBitmap>, <nTransColor>, <.k.> )

#command DCPS UNITS <nUnits> => PsSetUnit(<nUnits>)

#command @ <nRow>, <nCol> DCPS BARCODE <cText> ;
           [HEIGHT <nHeight>] ;
           [THICKNESS <nThick>] ;
           [<p:PRINTTEXT>] ;
           [TYPE <nType>] ;
           [<v:VERTICAL>]
  => ;
  PSBarCode( <nRow>, <nCol>, <cText>, <nHeight>, <nThick>, <.p.>, <nType>, <.v.> )

#command @ <x1> ,<y1>, <x2>, <y2> DCPS ELLIPSE          ;
                      [THICKNESS <thick>]               ;
                      [BORDERCOLOR <border>]            ;
                      [FILLCOLOR <fill>]                ;
                      [PATTERN <pattern>]               ;
  => PSEllipse(<x1>, <y1>, <x2>, <y2>, <thick>, DC_Color2PS(<border>)\[1], ;
               DC_Color2PS(<fill>)\[1], <pattern>)


