// Copyright (c) 2000-2007 AbeeLabs Systems, Inc.  ALL RIGHTS RESERVED.
//
// This source code can be used, modified, or copied by the licensee as long as
// the modifications (or the new binary resulting from a copy or modification of
// this source code) are used with AbeeLabs Systems' products. The source code
// is not redistributable as source code, but is redistributable as compiled
// and linked binary code. If the source code is used, modified, or copied by
// the licensee, AbeeLabs Systems Inc. reserves the right to receive from the
// licensee, upon request, at no cost to AbeeLabs Systems Inc., the modifications.
//
// AbeeLabs Systems Inc. does not warrant that the operation of this software
// will meet your requirements or that the operation of the software will be
// uninterrupted, be error free, or that defects in software will be corrected.
// This software is provided "AS IS" without warranty of any kind. The entire
// risk as to the quality and performance of this software is with the purchaser.
// If this software proves defective or inadequate, purchaser assumes the entire
// cost of servicing or repair. No oral or written information or advice given
// by an AbeeLabs Systems Inc. representative shall create a warranty or in any
// way increase the scope of this warranty.


// CAUTION:  Only true-type fonts will work with PDF output.
//           Any others will cause an IDSC.


#include "PSCRIPT.CH"
#INCLUDE "dcps.CH"
#INCLUDE "dcdialog.CH"

#define COLOR_RED        GraMakeRGBColor( { 255,   0,   0 } )
#define COLOR_DARKRED    GraMakeRGBColor( { 127,   0,   0 } )
#define COLOR_GREEN      GraMakeRGBColor( {   0, 255,   0 } )
#define COLOR_DARKGREEN  GraMakeRGBColor( {   0, 127,   0 } )
#define COLOR_BLUE       GraMakeRGBColor( {   0,   0, 255 } )
#define COLOR_DARKBLUE   GraMakeRGBColor( {   0,   0, 127 } )
#define COLOR_CYAN       GraMakeRGBColor( {   0, 255, 255 } )
#define COLOR_DARKCYAN   GraMakeRGBColor( {   0, 127, 127 } )
#define COLOR_YELLOW     GraMakeRGBColor( { 255, 255,   0 } )
#define COLOR_BROWN      GraMakeRGBColor( { 127, 127,   0 } )
#define COLOR_PINK       GraMakeRGBColor( { 255,   0, 255 } )
#define COLOR_DARKPINK   GraMakeRGBColor( { 127,   0, 127 } )
#define COLOR_WHITE      GraMakeRGBColor( { 255, 255, 255 } )
#define COLOR_BLACK      GraMakeRGBColor( {   0,   0,   0 } )
#define COLOR_PALEGRAY   GraMakeRGBColor( { 192, 192, 192 } )
#define COLOR_DARKGRAY   GraMakeRGBColor( { 127, 127, 127 } )
#define COLOR_ORANGE     GraMakeRGBColor( { 253, 120,  41 } )
#define COLOR_LTORANGE   GraMakeRGBColor( { 250, 205,   0 } )
#define COLOR_LTBLUE     GraMakeRGBColor( {  30, 187, 255 } )
#define COLOR_LTYELLOW   GraMakeRGBColor( { 128, 128,   0 } )
#define COLOR_DKYELLOW   GraMakeRGBColor( { 212, 212,   0 } )
#define COLOR_DKBROWN    GraMakeRGBColor( {  72,  72,   0 } )
#define COLOR_SLATEGRAY  GraMakeRGBColor( { 158, 182, 205 } )
#define COLOR_SILVER     GraMakeRGBColor( { 192, 192, 192 } )
#define COLOR_ICEGREEN   GraMakeRGBColor( { 222, 255, 189 } )

#define dbINV_MASTER 1
#define dbINV_DETAIL 2
#define CR           Chr(13)
#define LF           Chr(10)
#define CRLF         Chr(13) + Chr(10)
#define CRLF2        CRLF + CRLF
#define SOFTCR       Chr(141)
#define TICK         .1

#define PC_BOLDON    1
#define PC_BOLDOFF   2
#define PC_ITALICON  3
#define PC_ITALICOFF 4
#define PC_UNDERON   5
#define PC_UNDEROFF  6
#define PC_STRIKEON  7
#define PC_STRIKEOFF 8
#define PC_SET8CPI   9
#define PC_SET10CPI  10
#define PC_SET12CPI  11
#define PC_SET15CPI  12
#define PC_SET17CPI  13
#define PC_SET18CPI  14
#define PC_SET20CPI  15
#define PC_SET6LPI   16
#define PC_SET8LPI   17

#define PC_NORMAL    PC_SET10CPI
#define PC_COMPRESS  PC_SET17CPI

/*-----------------------------------------------------------------------------
Procedure ..: Main()
Description : PageScript 32 Main function (entry point)
-----------------------------------------------------------------------------*/
Function Main()

LOCAL GetList[0], i, nRow := 0, oDlg
Local nError
Local nFile   := 1
Local aTest   := {"PageScript 32 test page", ;
                  "Rotated text", ;
                  "Current page size", ;
                  "Pattern test", ;
                  "Printing an invoice", ;
                  "Bill of landing", ;
                  "Customer list example", ;
                  "Graphic example (Landscape)", ;
                  "Simulating plain text", ;
                  "Working with Pixels unit", ;
                  "TextBox demo", ;
                  "Barcode types", ;
                  "List all installed printers", ;
                  "Printer paper bins/trays list", ;
                  "Font list", ;
                  "Font size test", ;
                  "Printer capabilities", ;
                  "Ascii to Ansi test", ;
                  "Duplex test (Default printer must support)", ;
                  "Printing on Legal page size (Printer must have Legal paper)", ;
                  "Print RAW data on default printer", ;
                  "Print a document in EMULATION mode", ;
                  "Print text with default parameters", ;
                  "eXpress++ style Print with Xbase++ parameters (1)", ;
                  "eXpress++ style Print with Xbase++ parameters (2)", ;
                  "eXpress++ style Print with Xbase++ parameters (3)", ;
                  "eXpress++ style Print with Xbase++ parameters (4)", ;
                  "eXpress++ style Print with Xbase++ parameters (5)" }


Local aProc   := { {|| PSTestPage()          }, ;
                   {|| RotatedText()         }, ;
                   {|| DC_MsgBox(DC_XtoC(AbeePageSize())) }, ;
                   {|| AbeePatterns()        }, ;
                   {|| AbeeInvoice()         }, ;
                   {|| AbeePuroLater()       }, ;
                   {|| AbeeCustList()        }, ;
                   {|| AbeeGraphic()         }, ;
                   {|| AbeeText()            }, ;
                   {|| AbeePixels()          }, ;
                   {|| AbeeTextBox()         }, ;
                   {|| AbeeBarCode()         }, ;
                   {|| AbeePrinters()        }, ;
                   {|| AbeePaperBins()       }, ;
                   {|| AbeeFonts()           }, ;
                   {|| AbeePointSize()       }, ;
                   {|| AbeePrnCaps()         }, ;
                   {|| AbeeConvert()         }, ;
                   {|| AbeeDuplex()          }, ;
                   {|| AbeeLegal()           }, ;
                   {|| AbeeRawData()         }, ;
                   {|| AbeeEmuData()         }, ;
                   {|| AbeeAutoTextCoor()    }, ;
                   {|n| ExpressStylePrint1(n)}, ;
                   {|n| ExpressStylePrint2(n)}, ;
                   {|n| ExpressStylePrint3(n)}, ;
                   {|n| ExpressStylePrint4(n)}, ;
                   {|n| ExpressStylePrint5(n)}}


IF !((nError := PSInit()) == PSE_NOERROR)
  IF nError == PSE_DLLNOTLOADED
     DC_WinAlert("PageScript 32 DLL not loaded")
  ELSEIF nError == PSE_NOTINITIALIZED
     DC_WinAlert("PageScript 32 not initialized")
  ELSE
     DC_WinAlert("Unknown error")
  ENDIF
  QUIT
ENDIF

// Set the decimal separator. This is not necessary
// since the default separator is already the period.
PSSetDecimalSep(".")

FOR i := 1 TO Len(aTest)
  nRow += 1.1
  @ nRow,0 DCPUSHBUTTONXP CAPTION aTest[i] ;
        ACTION ActionBlock(aProc,i,@nFile,@oDlg) ;
        SIZE 60,1 FONT '11.Arial' ;
        GRADIENT 5 RADIUS 15;
        COLOR COLOR_WHITE,  COLOR_DARKPINK ;
        MOUSECOLOR  COLOR_BLACK, COLOR_LTORANGE ;
        SELECTCOLOR COLOR_BLACK, COLOR_ORANGE

NEXT

DCREAD GUI FIT TITLE 'PSScript Test Program' ;
       EVAL {||nError := PSInit()} SETAPPWINDOW ;
       PARENT @oDlg

RETURN nil

* ---------

STATIC FUNCTION ActionBlock( aProc, i, nFile, oDlg )

RETURN {||oDlg:hide(),CallProc(aProc,i,@nFile),oDlg:show()}

* ---------

STATIC FUNCTION CallProc( aProc, nChoice, nFile )

LOCAL nDevice := 0

IF nChoice == 8
  PSSetOrientation(APS_LANDSCAPE)
ELSEIF nChoice == 19
  PSSetDuplex(DMDUP_VERTICAL)
ENDIF

IF nChoice == 21
  nDevice := DEV_PRINTER
ELSE
  nDevice := SelectDevice(nChoice)
ENDIF

IF nDevice == 0
  PSSetFileName(nil)
  RETURN .f.
ELSEIF nDevice < 4
  PSSetDevice(nDevice)
ENDIF

IF nDevice == DEV_PDFFILE // 3
  PSSetFileName("Test" + AllTrim(Str(nFile, 3, 0)) + ".pdf")
ENDIF

IF nChoice != 21 .AND. nDevice == DEV_PRINTER
  PsInit()
  IF PSPrintDialog()
    Eval(aProc[nChoice],nDevice)
  ENDIF
ELSE
  Eval(aProc[nChoice],nDevice)
ENDIF

IF nDevice == DEV_PDFFILE
  DCMSGBOX "Document saved in Test" + AllTrim(Str(nFile, 3, 0)) + ".pdf"
  nFile++
ENDIF

Return .t.

* ---------

PROC appsys ; RETURN

/*-----------------------------------------------------------------------------
Procedure ..: PSTestPage()
Description : PageScript 32 test page
-----------------------------------------------------------------------------*/
Function PSTestPage()

Local nLoop
Local nLine    := 55
Local nR       := 255
Local nG       := 128
Local nB       := 0
Local cText    := "PageScript"
Local cRainbow := "Rainbow text with R G B"
Local aFonts   := {{ 97, APS_PLAIN     ,  6}, {101, APS_BOLD     , 8}, {106, APS_ITALIC   , 10}, ;
                   {110, APS_BOLDITALIC, 12}, {116, APS_UNDERLINE, 8}, {121, APS_STRIKEOUT, 10}}

PSBeginDoc(, "PageScript 32 test page", APS_PORTRAIT)

PSSetFont(APS_ARIAL, APS_BOLD, 10)

// Pattern test
@10, 10 TEXTOUT "Patterns"
for nLoop := APS_SOLID to APS_VERTICAL
   @15, (nLoop * 10) + 10 FRAME TO 25, (nLoop * 10) + 20  THICKNESS .5  COLOR APS_BLACK, APS_WHITE  PATTERN nLoop
next nLoop

@27.5, 10 LINE TO 27.5, 190  THICKNESS 1 COLOR APS_BLACK

// Clipper compatible color test
@30, 10 TEXTOUT "PageScript colors"
@33,163 FRAME TO 47,167  THICKNESS 0  COLOR APS_WHITE, APS_BLACK
@33,173 FRAME TO 47,177  THICKNESS 0  COLOR APS_WHITE, APS_BLACK

for nLoop := Abs(APS_BLACK) to Abs(APS_WHITE)
   @35, (nLoop * 10) FRAME TO 45, (nLoop * 10) + 10  THICKNESS .5  COLOR APS_BLACK, -nLoop
next nLoop

@35,170 FRAME TO 45,180  THICKNESS .5  COLOR APS_BLACK, APS_NONE

@47.5, 10 LINE TO 47.5, 190  THICKNESS 1 COLOR APS_BLACK

// RGB color test
@50, 10 TEXTOUT "RGB colors"
for nLoop := 1 to 255 step 5
   PSLine(nLine, 10, nLine,  30, 2, RGB(nR, nG, nB))
   PSLine(nLine, 35, nLine,  55, 2, RGB(nR, nB, nG))
   PSLine(nLine, 60, nLine,  80, 2, RGB(nG, nB, nR))
   PSLine(nLine, 85, nLine, 105, 2, RGB(nG, nR, nB))
   PSLine(nLine,110, nLine, 130, 2, RGB(nB, nG, nR))
   PSLine(nLine,135, nLine, 155, 2, RGB(nB, nR, nG))
   nLine += .5
   nR -= 5
   nG += 2
   nB += 5
next nLoop

@82.5, 10 LINE TO 82.5, 190  THICKNESS 1  COLOR APS_BLACK

// Various fonts test
@85, 10 TEXTOUT "Some fonts"
@90, 10 FRAME TO  95, 190  THICKNESS  0  COLOR APS_WHITE, APS_BLACK
@95, 10 FRAME TO 125,  40  THICKNESS  0  COLOR APS_WHITE, APS_BLACK

for nLoop := 100 to 125 step 5
   @nLoop, 10 LINE TO nLoop, 190  THICKNESS .75 COLOR APS_BLACK
next nLoop

for nLoop := 95 to 125 step 5
   @nLoop, 10 LINE TO nLoop, 40   THICKNESS  1  COLOR APS_WHITE
next nLoop

for nLoop := 70 to 190 step 30
   @90, nLoop LINE TO 125, nLoop  THICKNESS .75 COLOR APS_BLACK
next nLoop

for nLoop := 40 to 160 step 30
   @90, nLoop LINE TO  95, nLoop  THICKNESS  1  COLOR APS_WHITE
next nLoop

PSSetFont(APS_ARIAL, APS_BOLD, 8, APS_WHITE)
PSSetJustify(APS_CENTER)

@ 91, 25 TEXTOUT "Font point and style"
@ 91, 55 TEXTOUT "System"
@ 91, 85 TEXTOUT "Courier"
@ 91,115 TEXTOUT "Arial"
@ 91,145 TEXTOUT "Times"
@ 91,175 TEXTOUT "Verdana"

@ 96, 25 TEXTOUT "Plain 6 points"
@101, 25 TEXTOUT "Bold 8 points"
@106, 25 TEXTOUT "Italic 10 points"
@111, 25 TEXTOUT "Bold Italic 12 points"
@116, 25 TEXTOUT "Underline 8 points"
@121, 25 TEXTOUT "StrikeOut 10 points"

PSSetJustify(APS_LEFT)

for nLoop := 1 to 6
   PSSetFont(, aFonts[nLoop, 2], aFonts[nLoop, 3], APS_BLACK)
   @aFonts[nLoop, 1], 41 TEXTOUT cText FONT APS_SYSTEM
   @aFonts[nLoop, 1], 71 TEXTOUT cText FONT APS_COURIER
   @aFonts[nLoop, 1],101 TEXTOUT cText FONT APS_ARIAL
   @aFonts[nLoop, 1],131 TEXTOUT cText FONT APS_TIMES
   @aFonts[nLoop, 1],161 TEXTOUT cText FONT APS_VERDANA
next nLoop

@126.5, 10 LINE TO 126.5, 190  THICKNESS 1  COLOR APS_BLACK

// Shapes and bitmap test
PSSetFont(APS_ARIAL, APS_BOLD, 10, APS_BLACK)  // Resets the font properties
@128, 10 TEXTOUT "Shapes (Oval, Rectangle, Line)"
@220, 10 TEXTOUT "Text rotation, size and colors"

@133, 10 FRAME   TO 167, 60   THICKNESS 0  COLOR APS_NONE , APS_MAGENTA  PATTERN APS_FDIAGONAL
@140, 77 FRAME   TO 160, 123  THICKNESS 0  COLOR APS_NONE , APS_BLUE

@135, 80 ELLIPSE TO 165, 120  THICKNESS 2  COLOR APS_BLUE , APS_MAGENTA  PATTERN APS_CROSS
@135,130 ELLIPSE TO 165, 160  THICKNESS 4  COLOR APS_RED  , APS_YELLOW   PATTERN APS_SOLID

@140,170 FRAME   TO 160, 190  THICKNESS 2  COLOR APS_BCYAN, APS_BLUE     PATTERN APS_FDIAGONAL
@140,170 LINE    TO 160, 190  THICKNESS 2  COLOR APS_RED
@160,170 LINE    TO 140, 190  THICKNESS 2  COLOR APS_GREEN

@172, 10 LINE    TO 172, 190  THICKNESS 1  COLOR APS_BLACK
@175, 10 TEXTOUT "Bitmaps and JPEGs images"

PSSetFont(APS_ARIAL, APS_PLAIN, 8, APS_BLACK)
@180, 10 TEXTOUT "Natural size"
@180, 50 TEXTOUT "Stretched"
@180,100 TEXTOUT "Calculated Width"
@210,143 TEXTOUT "Calculated Height" ANGLE 90

PSBitmap(185,  10,   0,   0, "LOGOABEE.BMP") // Natural size
PSBitmap(185,  50, 195,  80, "LOGOABEE.BMP") // Stretch
PSBitmap(185, 100, 215,   0, "PS4.JPG")      // Calculated Width
PSBitmap(185, 150,   0, 180, "PS4.JPG")      // Calculated Height

@218, 10 LINE    TO 218, 190  THICKNESS 1  COLOR APS_BLACK

// Font roration, size and color
@250, 10 TEXTOUT "Text rotated at 90" ANGLE 90

for nLoop := 0 to 330 step 30
   @240, 30 TEXTOUT "        Rotation" SIZE 6 ANGLE nLoop
next nLoop

nLine := 225
for nLoop := 6 to 8 step .25
   @nLine, 50 TEXTOUT "Font size = " + LTrim(Str(nLoop, 5, 2)) SIZE nLoop
   nLine += 3
next nLoop

@220, 80 TEXTOUT "PageScript colors"

nLine := 225
for nLoop := Abs(APS_BLACK) to Abs(APS_PALEGRAY)
   @nLine, 80  TEXTOUT " Colored text " SIZE 7  STYLE APS_BOLD  COLOR -(nLoop), RGB(nLoop * 25 + 25, nLoop * 15 + 35, nLoop * 10 + 120)
   @nLine, 100 TEXTOUT " Colored text " SIZE 7  STYLE APS_BOLD  COLOR -(nLoop + 8), RGB(nLoop * 15 + 50, nLoop * 10 + 75, nLoop * 35 + 40)
   nLine += 3.5
next nLoop

nR := 255
nG := 128
nB := 0

@220, 125 TEXTOUT "RGB colors"

for nLoop := 0 to (Len(cRainbow) - 1)
   @225,125 + (nLoop * 2.5) TEXTOUT SubStr(cRainbow, nLoop + 1, 1) SIZE 10  STYLE APS_BOLD  COLOR RGB(nR, nG, nB)
   @230,125 + (nLoop * 2.5) TEXTOUT SubStr(cRainbow, nLoop + 1, 1) SIZE 10  STYLE APS_BOLD  COLOR RGB(nR, nB, nG)
   @235,125 + (nLoop * 2.5) TEXTOUT SubStr(cRainbow, nLoop + 1, 1) SIZE 10  STYLE APS_BOLD  COLOR RGB(nG, nR, nB)
   @240,125 + (nLoop * 2.5) TEXTOUT SubStr(cRainbow, nLoop + 1, 1) SIZE 10  STYLE APS_BOLD  COLOR RGB(nG, nB, nR)
   @245,125 + (nLoop * 2.5) TEXTOUT SubStr(cRainbow, nLoop + 1, 1) SIZE 10  STYLE APS_BOLD  COLOR RGB(nB, nR, nG)
   nR -= 15
   nG += 20
   nB += 15
next nLoop

PSEndDoc()

Return NIL

/*-----------------------------------------------------------------------------
Function ...: RotatedText()
Description : Rotated text sample
Author .....: Stephan St-Denis
Date .......: September 2000
-----------------------------------------------------------------------------*/
Static Function RotatedText()

Local nLoop := 0

PSBeginDoc(, "Rotated text sample", APS_PORTRAIT)

   PSSetFont(APS_ARIAL, APS_BOLD, 4)

   @100, 100 TEXTOUT "X"
   for nLoop := 0 to 345 step 15
      @100, 100 TEXTOUT "            Rotated text is easy using PageScript !" ANGLE nLoop
   next nLoop

   @200, 100 TEXTOUT "X" JUSTIFY APS_CENTER
   for nLoop := 0 to 345 step 15
      @200, 100 TEXTOUT "            Rotated text is easy using PageScript !" ANGLE nLoop JUSTIFY APS_CENTER
   next nLoop

ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeePageSize()
Description : Return current printer page size
Author .....: Stephan St-Denis
Date .......: April 2001
-----------------------------------------------------------------------------*/
Static Function AbeePageSize()

Local  nPaper
Static aPaper := { ;
   "LETTER", ;
   "LETTERSMALL", ;
   "TABLOID", ;
   "LEDGER", ;
   "LEGAL", ;
   "STATEMENT", ;
   "EXECUTIVE", ;
   "A3", ;
   "A4", ;
   "A4SMALL", ;
   "A5", ;
   "B4", ;
   "B5", ;
   "FOLIO", ;
   "QUARTO", ;
   "10X14", ;
   "11X17", ;
   "NOTE", ;
   "ENV_9", ;
   "ENV_10", ;
   "ENV_11", ;
   "ENV_12", ;
   "ENV_14", ;
   "CSHEET", ;
   "DSHEET", ;
   "ESHEET", ;
   "ENV_DL", ;
   "ENV_C5", ;
   "ENV_C3", ;
   "ENV_C4", ;
   "ENV_C6", ;
   "ENV_C65", ;
   "ENV_B4", ;
   "ENV_B5", ;
   "ENV_B6", ;
   "ENV_ITALY", ;
   "ENV_MONARCH", ;
   "ENV_PERSONAL", ;
   "FANFOLD_US", ;
   "FANFOLD_STD_GERMAN", ;
   "FANFOLD_LGL_GERMAN", ;
   "ISO_B4", ;
   "JAPANESE_POSTCARD", ;
   "9X11", ;
   "10X11", ;
   "15X11", ;
   "ENV_INVITE", ;
   "RESERVED_48", ;
   "RESERVED_49", ;
   "LETTER_EXTRA", ;
   "LEGAL_EXTRA", ;
   "TABLOID_EXTRA", ;
   "A4_EXTRA", ;
   "LETTER_TRANSVERSE", ;
   "A4_TRANSVERSE", ;
   "LETTER_EXTRA_TRANSVERSE", ;
   "A_PLUS", ;
   "B_PLUS", ;
   "LETTER_PLUS", ;
   "A4_PLUS", ;
   "A5_TRANSVERSE", ;
   "B5_TRANSVERSE", ;
   "A3_EXTRA", ;
   "A5_EXTRA", ;
   "B5_EXTRA", ;
   "A2", ;
   "A3_TRANSVERSE", ;
   "A3_EXTRA_TRANSVERSE"}

nPaper := PSGetPageSize()

if nPaper > Len(aPaper)
   Return "UNDEFINED"
endif

Return aPaper[nPaper]

/*-----------------------------------------------------------------------------
Function ...: AbeePatterns()
Description : Patterns test
Author .....: Stephan St-Denis
Date .......: April 2005
-----------------------------------------------------------------------------*/
Static Function AbeePatterns()

Local nLoop

PSBeginDoc(, "Abee PageScript Patterns test", APS_PORTRAIT)
   @10, 25 LINE    TO 150, 25  THICKNESS 1  COLOR APS_BLACK

   for nLoop := APS_SOLID to APS_VERTICAL
      @15, (nLoop * 10) + 10 FRAME TO 25, (nLoop * 10) + 20  THICKNESS .5  COLOR APS_BLACK, APS_WHITE  PATTERN nLoop
      @30, (nLoop * 10) + 10 FRAME TO 40, (nLoop * 10) + 20  THICKNESS .5  COLOR APS_RED  , APS_BLUE   PATTERN nLoop
      @45, (nLoop * 10) + 10 FRAME TO 55, (nLoop * 10) + 20  THICKNESS .5  COLOR APS_GREEN, APS_YELLOW PATTERN nLoop
      @60, (nLoop * 10) + 10 FRAME TO 70, (nLoop * 10) + 20  THICKNESS .5  COLOR APS_BLACK, APS_NONE   PATTERN nLoop
      @75, (nLoop * 10) + 10 FRAME TO 85, (nLoop * 10) + 20  THICKNESS .5  COLOR APS_NONE , APS_BLACK  PATTERN nLoop
   next nLoop

PSEndDoc()

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeeInvoice()
Description : Invoice example
Author .....: Stephan St-Denis
Date .......: August 1999
-----------------------------------------------------------------------------*/
Static Function AbeeInvoice()

dbSelectArea(dbINV_DETAIL)
use InvDetai exclusive

dbSelectArea(dbINV_MASTER)
use InvMaste exclusive

BEGINDOC WITH 0 TITLE "Abee invoice" ORIENTATION APS_PORTRAIT
   PSSetDecimalSep(".")

   // Default unit = milimeters
   PSFrame(10, 140, 20, 200, 0, , APS_PALEGRAY)
   PSFrame(25, 155, 35, 190, 0, , APS_PALEGRAY)

   // WARNING : Make sure that this is a valid path
   PSBitmap(10, 10, 32, 85, "\" + CurDir() + "\LOGOABEE.BMP", , .t.)

   PSFrame( 73,  10,  80, 206, 0, , APS_PALEGRAY)
   PSFrame( 86,  10,  92, 206, 0, , APS_PALEGRAY)
   PSFrame( 99,  10, 105, 206, 0, , APS_PALEGRAY)
   PSFrame(215,  10, 265, 130, 0, , APS_PALEGRAY)

   PSLine( 73,   10,  73, 206, .5, APS_BLUE)
   PSLine( 80,   10,  80, 206, .5, APS_BLACK)
   PSLine( 86,   10,  86, 206, .5, APS_BLACK)
   PSLine( 92,   10,  92, 206, .5, APS_BLACK)
   PSLine( 99,   10,  99, 206, .5, APS_BLACK)
   PSLine(105,   10, 105, 206, .5, APS_BLACK)
   PSLine(215,   10, 215, 206, .5, APS_BLACK)
   PSLine(265,   10, 265, 206, .5, APS_BLACK)

   PSLine(215,  130, 215, 206, .5, APS_BLACK)
   PSLine(223,  130, 223, 206, .5, APS_BLACK)
   PSLine(231,  130, 231, 206, .5, APS_BLACK)
   PSLine(240,  130, 240, 206, .5, APS_BLACK)
   PSLine(248,  130, 248, 206, .5, APS_BLACK)
   PSLine(257,  130, 257, 206, .5, APS_BLACK)

   PSLine(215,  130, 265, 130, .5, APS_BLACK)
   PSLine(215,  169, 265, 169, .5, APS_BLACK)

   PSLine( 73,   10, 265,  10, .5, APS_BLACK)
   PSLine( 73,  206, 265, 206, .5, APS_BLACK)

   PSLine( 73,   30,  86,  30, .5, APS_BLACK)
   PSLine( 73,   70,  86,  70, .5, APS_BLACK)
   PSLine( 73,  124,  86, 124, .5, APS_BLACK)
   PSLine( 73,  165,  86, 165, .5, APS_BLACK)

   PSLine( 86,   81,  99,  81, .5, APS_BLACK)
   PSLine( 86,  125,  99, 125, .5, APS_BLACK)
   PSLine( 86,  156,  99, 156, .5, APS_BLACK)
   PSLine( 86,  177,  99, 177, .5, APS_BLACK)

   PSLine( 99,  123, 105, 123, .5, APS_BLACK)
   PSLine( 99,  151, 105, 151, .5, APS_BLACK)
   PSLine( 99,  179, 105, 179, .5, APS_BLACK)

   PSSetFont(APS_TIMES,, 8, APS_BLACK)
   @ 12,170 TEXTOUT "INVOICE"            JUSTIFY APS_CENTER  FONT APS_ARIAL  STYLE APS_BOLD  POINT 14
   @ 28,158 TEXTOUT "No"                 FONT APS_ARIAL
   @ 13,90  TEXTOUT "Working"
   @ 16,90  TEXTOUT "like bees,"
   @ 19,90  TEXTOUT "to bring you"
   @ 22,90  TEXTOUT "the best software."
   @ 33,50  TEXTOUT "70, de la Gare Street, St.Jerome, (Quebec), Canada, J7Z 2B8"  JUSTIFY APS_CENTER
   @ 36,50  TEXTOUT "Phone: 555 555-5555 - Fax: (555) 555-5550"                    JUSTIFY APS_CENTER

   PSSetFont(APS_ARIAL,, 7)
   @ 75, 20 TEXTOUT "CUSTOMER #"         JUSTIFY APS_CENTER
   @ 75, 52 TEXTOUT "PURCHASE ORDER #"   JUSTIFY APS_CENTER
   @ 75, 98 TEXTOUT "SHIP VIA"           JUSTIFY APS_CENTER
   @ 75,145 TEXTOUT "PHONE #"            JUSTIFY APS_CENTER
   @ 75,185 TEXTOUT "FAX #"              JUSTIFY APS_CENTER

   @ 88, 45 TEXTOUT "SALESPERSON"        JUSTIFY APS_CENTER
   @ 88,103 TEXTOUT "TERMS"              JUSTIFY APS_CENTER
   @ 88,140 TEXTOUT "DATE"               JUSTIFY APS_CENTER
   @ 88,167 TEXTOUT "OUR ORDER #"        JUSTIFY APS_CENTER
   @ 88,191 TEXTOUT "SHIP DATE"          JUSTIFY APS_CENTER

   @101, 75 TEXTOUT "DESCRIPTION"        JUSTIFY APS_CENTER
   @101,138 TEXTOUT "QTY"                JUSTIFY APS_CENTER
   @101,165 TEXTOUT "UNIT PRICE"         JUSTIFY APS_CENTER
   @101,192 TEXTOUT "EXTENSION"          JUSTIFY APS_CENTER

   @218,150 TEXTOUT "SUB-TOTAL"          JUSTIFY APS_CENTER
   @226,150 TEXTOUT "SALES TAX 1"        JUSTIFY APS_CENTER
   @234,150 TEXTOUT "SALES TAX 2"        JUSTIFY APS_CENTER
   @243,150 TEXTOUT "TOTAL"              JUSTIFY APS_CENTER
   @252,150 TEXTOUT "AMOUNT RECEIVED"    JUSTIFY APS_CENTER
   @260,150 TEXTOUT "BALANCE DUE"        JUSTIFY APS_CENTER

   InvoiceHeader()  // Print the header
   InvoiceDetail()  // Print the detail
   InvoiceTotal()   // Print the total

ENDDOC

dbCloseAll()

Return NIL

/*-----------------------------------------------------------------------------
Function ...: InvoiceHeader()
Description : Print the invoice header section
Author .....: Stephan St-Denis
Date .......: August 1999
-----------------------------------------------------------------------------*/
Static Function InvoiceHeader()

PSSetFont(APS_ARIAL, APS_PLAIN, 10, APS_BLACK, APS_NONE)

PSSetJustify(APS_LEFT)
@28,165 TEXTOUT dbINV_MASTER->invoice  picture "999999"  STYLE APS_BOLD
@45,20  TEXTOUT dbINV_MASTER->name
@50,20  TEXTOUT dbINV_MASTER->address1
@55,20  TEXTOUT dbINV_MASTER->address2
@60,20  TEXTOUT dbINV_MASTER->address3

PSSetJustify(APS_CENTER)
@81,20  TEXTOUT AllTrim(dbINV_MASTER->custno)  POINT 8
@81,50  TEXTOUT AllTrim(dbINV_MASTER->orderno)
@81,95  TEXTOUT AllTrim(dbINV_MASTER->shipvia)
@81,145 TEXTOUT dbINV_MASTER->phone    picture "@R (999) 999-9999"
@81,185 TEXTOUT dbINV_MASTER->fax      picture "@R (999) 999-9999"

@94,45  TEXTOUT AllTrim(dbINV_MASTER->sales)
@94,103 TEXTOUT AllTrim(dbINV_MASTER->terms)
@94,140 TEXTOUT Date()
@94,168 TEXTOUT dbINV_MASTER->ourno    picture "999999"
@94,190 TEXTOUT dbINV_MASTER->shipdate

Return NIL

/*-----------------------------------------------------------------------------
Function ...: InvoiceDetail()
Description : Print the invoice detail section
Author .....: Stephan St-Denis
Date .......: August 1999
-----------------------------------------------------------------------------*/
Static Function InvoiceDetail()

Local nLine := 107

PSSetFont(APS_ARIAL, APS_PLAIN, 10, APS_BLACK, APS_NONE)

while ! dbINV_DETAIL->(Eof())
   @nLine,15  TEXTOUT dbINV_DETAIL->descrip                                             JUSTIFY APS_LEFT
   @nLine,145 TEXTOUT dbINV_DETAIL->qty                            PICTURE "99,999.99"  JUSTIFY APS_DECIMAL
   @nLine,173 TEXTOUT dbINV_DETAIL->unitprice                      PICTURE "99,999.99"  JUSTIFY APS_DECIMAL
   @nLine,200 TEXTOUT dbINV_DETAIL->qty * dbINV_DETAIL->unitprice  PICTURE "99,999.99"  JUSTIFY APS_DECIMAL

   dbINV_DETAIL->(dbSkip())

   nLine += 4

   if nLine > 210 .and. ! dbINV_DETAIL->(Eof())
      InvoiceHeader()
      nLine := 107
   endif
enddo

Return NIL

/*-----------------------------------------------------------------------------
Function ...: InvoiceTotal()
Description : Print the invoice total section
Author .....: Stephan St-Denis
Date .......: August 1999
-----------------------------------------------------------------------------*/
Static Function InvoiceTotal()

PSSetFont(APS_ARIAL, APS_PLAIN, 10, APS_BLACK, APS_NONE)

PSSetJustify(APS_DECIMAL)
@218,200 TEXTOUT "999,999.99"
@226,200 TEXTOUT "999,999.99"
@234,200 TEXTOUT "999,999.99"
@243,200 TEXTOUT "999,999.99"
@252,200 TEXTOUT "999,999.99"
@260,200 TEXTOUT "999,999.99"

PSSetJustify(APS_LEFT)
@220,15  TEXTOUT "Abeelabs Systems inc. is working hard to make programmer's"
@225,15  TEXTOUT "life easier"

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeePuroLater()
Description : A bill of Lading example with a bit of humour.
Author .....: Stephan St-Denis
Date .......: April 2000
-----------------------------------------------------------------------------*/
Static Function AbeePuroLater()

Local nLoop
Local cText := "Paradise is engineered on Vos, the hidden sister planet of Earth that " + ;
               "orbits the sun directly opposite our own planet; sirens and satyrs dance " + ;
               "to the music of love and bounty; the seer arrives to warn of the approaching " + ;
               "Dark and is ignored. Los the Irrational attempts to stifle the music; " + ;
               "the sirens and satyrs are concerned, but are too apathetic to act; the music " + ;
               "wheel on which Vos rotates grinds to a halt; the birds and insects leave " + ;
               "Paradise; the Darkness begins. Many sirens and satyrs perish in the frigid " + ;
               "Darkness; Emau stumbles across a hollow reed in the forests and creates music; " + ;
               "Los the Irrational battles Emau with Silence; Emau triumphs; light returns to Paradise."

BEGINDOC WITH 0 TITLE "Bill of Lading example"  ORIENTATION APS_PORTRAIT
	PSSetUnit(APS_MILL)

   // Puro Logo
   PSBitmap(15, 8, 22, 50, "\" + CurDir() + "\PUROLOGO.BMP")

   // Top/Left Two frames
   PSFrame(25,  8,  62, 100, 2, APS_BLACK, APS_WHITE, APS_SOLID)
   PSFrame(65,  8, 112, 100, 2, APS_BLACK, APS_WHITE, APS_SOLID)

   @ 27, 55 TEXTOUT "SENDER (FROM)"          FONT APS_ARIAL  SIZE 8                   JUSTIFY APS_CENTER
   @ 33, 10 TEXTOUT "AbeeLabs Systems Inc."  FONT APS_ARIAL  SIZE 8   STYLE APS_BOLD
   @ 37, 10 TEXTOUT "70, de la Gare Street"  FONT APS_ARIAL  SIZE 8   STYLE APS_BOLD
   @ 42, 10 TEXTOUT "St. Jerome, Quebec"     FONT APS_ARIAL  SIZE 8   STYLE APS_BOLD
   @ 51, 10 TEXTOUT "J7Z 2B8"                FONT APS_ARIAL  SIZE 8   STYLE APS_BOLD
   @ 56, 10 TEXTOUT "(999) 555-5555"         FONT APS_ARIAL  SIZE 8   STYLE APS_BOLD

   @ 67, 55 TEXTOUT "RECEIVER (TO)"          FONT APS_ARIAL  SIZE 10                  JUSTIFY APS_CENTER
   @ 72, 10 TEXTOUT "Liza Peabody"           FONT APS_ARIAL  SIZE 14  STYLE APS_BOLD
   @ 78, 10 TEXTOUT "Mistral Floors Ltd."    FONT APS_ARIAL  SIZE 14  STYLE APS_BOLD
   @ 84, 10 TEXTOUT "2211, Industrial blvd." FONT APS_ARIAL  SIZE 14  STYLE APS_BOLD
   @ 95, 10 TEXTOUT "Springfield, Ill 24551" FONT APS_ARIAL  SIZE 14  STYLE APS_BOLD
   @101, 10 TEXTOUT "(888) 555-1111"         FONT APS_ARIAL  SIZE 14  STYLE APS_BOLD

   @ 10,112 TEXTOUT "PACKAGE I.D. NO."       FONT APS_ARIAL  SIZE 8
   @  8,143 TEXTOUT "7 0 3  8 2 3  8 7 3 4"  FONT APS_ARIAL  SIZE 16  STYLE APS_BOLD
   @ 18,60  TEXTOUT "0 1 5 1 8 1 6 9 6"      FONT APS_ARIAL  SIZE 14  STYLE APS_BOLD
   @ 25,120 TEXTOUT "BILL CHARGES TO"        FONT APS_ARIAL  SIZE 8                   JUSTIFY APS_CENTER
   @ 25,145 TEXTOUT "TOTAL WEIGHT"           FONT APS_ARIAL  SIZE 8                   JUSTIFY APS_CENTER
   @ 25,170 TEXTOUT "PIECES"                 FONT APS_ARIAL  SIZE 8                   JUSTIFY APS_CENTER
   @ 25,192 TEXTOUT "DATE"                   FONT APS_ARIAL  SIZE 8                   JUSTIFY APS_CENTER

   @ 29,145 TEXTOUT "SUBJECT TO AUDIT"       FONT APS_ARIAL  SIZE 6                   JUSTIFY APS_CENTER
   @ 29,192 TEXTOUT "MO  DAY  YEAR"          FONT APS_ARIAL  SIZE 6                   JUSTIFY APS_CENTER

   @ 34,120 TEXTOUT "RECEIVER"               FONT APS_ARIAL  SIZE 10  STYLE APS_BOLD  JUSTIFY APS_CENTER
   @ 34,145 TEXTOUT "1 POUND"                FONT APS_ARIAL  SIZE 10  STYLE APS_BOLD  JUSTIFY APS_CENTER
   @ 34,170 TEXTOUT "1 OF 1"                 FONT APS_ARIAL  SIZE 10  STYLE APS_BOLD  JUSTIFY APS_CENTER
   @ 34,192 TEXTOUT Date()                   FONT APS_ARIAL  SIZE 10  STYLE APS_BOLD  JUSTIFY APS_CENTER

   @ 45,155 TEXTOUT "SERVICE OPTIONS"        FONT APS_ARIAL  SIZE 11  STYLE APS_BOLD + APS_ITALIC  JUSTIFY APS_CENTER

   @109,135 TEXTOUT "PIN"                    FONT APS_ARIAL  SIZE 6                   JUSTIFY APS_CENTER
   @108,160 TEXTOUT "7 0 3  8 2 3  8 7 3 4"  FONT APS_ARIAL  SIZE 10                  JUSTIFY APS_CENTER

   @115, 14 TEXTOUT "UNICODE"                FONT APS_ARIAL  SIZE 6                   JUSTIFY APS_CENTER
   @115, 60 TEXTOUT "AIRPORT CODE"           FONT APS_ARIAL  SIZE 6                   JUSTIFY APS_CENTER
   @115, 95 TEXTOUT "SERVICE GARANTEE"       FONT APS_ARIAL  SIZE 6                   JUSTIFY APS_CENTER

   @125, 14 TEXTOUT "32"                     FONT APS_ARIAL  SIZE 36  STYLE APS_BOLD  JUSTIFY APS_CENTER
   @141,205 TEXTOUT "45333 4.0000426033411"  FONT APS_ARIAL  SIZE 6                   JUSTIFY APS_RIGHT
   @143,  8 TEXTOUT "Fold this Bill of Lading on the dotted line and insert it into the labelope. Attach a Bill of Lading to each package." ;
                                             FONT APS_ARIAL  SIZE 8   STYLE APS_BOLD

   PSBarCode(112, 110, "A7038238734", 64, 1, .f., APS_BC39)

   for nLoop := 8 to 205 step 2
      PSLine(140, nLoop, 140, nLoop + 1, 1, APS_BLACK)
   next nLoop

   @157,  8 TEXTOUT "Description :"          FONT APS_ARIAL  SIZE 8   STYLE APS_BOLD
   PSLine(160, 27, 160, 115, 1, APS_BLACK)
   @162,  8 TEXTOUT "No Declared Value Entered in Software By Sender" FONT APS_ARIAL  SIZE 8   STYLE APS_BOLD

   @176,107 TEXTOUT "TRANSPORTATION CONDITIONS"                       FONT APS_ARIAL  SIZE 8   STYLE APS_BOLD  JUSTIFY APS_CENTER

   @180, 8 TO 192, 205 TEXTBOX "1)  " + cText  FONT APS_ARIAL  SIZE 7  COLOR APS_BLACK, APS_NONE
   @193, 8 TO 205, 205 TEXTBOX "2)  " + cText  FONT APS_ARIAL  SIZE 7  COLOR APS_BLACK, APS_NONE
   @206, 8 TO 212, 205 TEXTBOX "3)  " + cText  FONT APS_ARIAL  SIZE 7  COLOR APS_BLACK, APS_NONE
   @213, 8 TO 216, 205 TEXTBOX "4)  " + cText  FONT APS_ARIAL  SIZE 7  COLOR APS_BLACK, APS_NONE
   @218, 8 TO 230, 205 TEXTBOX "5)  " + cText  FONT APS_ARIAL  SIZE 7  COLOR APS_BLACK, APS_NONE
   @231, 8 TO 238, 205 TEXTBOX "6)  " + cText  FONT APS_ARIAL  SIZE 7  COLOR APS_BLACK, APS_NONE
   @239, 8 TO 254, 205 TEXTBOX "7)  " + cText  FONT APS_ARIAL  SIZE 7  COLOR APS_BLACK, APS_NONE

ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeeCustList()
Description : Customer list example
Author .....: Stephan St-Denis
Date .......: August 1999
-----------------------------------------------------------------------------*/
Static Function AbeeCustList()

Local nRow     := 7
Local nPage    := 1

use customer exclusive

// Add a watermark. Print it in the background
PSWaterMark({|| WaterMark()}, AWM_BACKGROUND)
PSSetPageSize(DMPAPER_LETTER)

PSBeginDoc(, "Customer list", APS_PORTRAIT)

   PSSetUnit(APS_TEXT)
   PSSetFont(APS_COURIER, APS_PLAIN, 12, APS_BLACK, APS_NONE)

   nRow := CustHeader(nPage)

   while ! Eof()

      PSTextOut(nRow  , 0, field->custno,, APS_LEFT)
      PSTextOut(nRow  ,11, field->name)
      PSTextOut(nRow+1,11, field->address1)
      PSTextOut(nRow+2,11, field->address2)
      PSTextOut(nRow+3,11, field->address3)
      PSTextOut(nRow  ,51, field->phone   , "@R (999) 999-9999")
      PSTextOut(nRow+1,51, field->fax     , "@R (999) 999-9999")
      PSTextOut(nRow  ,78, field->due     , "999,999,999.99", APS_DECIMAL)

      PSLine(nRow + 4.5, 0, nRow + 4.5, 80, .5, APS_BLACK)
      nRow += 5

      if nRow > 58
         PSNewPage()
         nPage++
         nRow := CustHeader(nPage)
      endif

      dbSkip()

   enddo

PSEndDoc()

PSSetPageSize(DMPAPER_LETTER)

// Disable watermark.
PSWaterMark()

dbCloseAll()

Return NIL

/*-----------------------------------------------------------------------------
Function ...: CustHeader(<n>) -> nRow
Description : Prints the customer list header
Author .....: Stephan St-Denis
Date .......: August 1999
-----------------------------------------------------------------------------*/
Static Function CustHeader(nPage)

PSTextOut(0 , 0, Date())
PSTextOut(0 ,70, "Page : " + Str(nPage, 3, 0))
PSTextOut(0 ,39, "Your company name here",, APS_CENTER)
PSTextOut(2 ,39, "Customer list in no particular order",, APS_CENTER)
PSTextOut(4 , 0, "Cust. No   Name and address                           Phone/Fax       Amount due")

PSLine(3.25, 0, 3.25, 80, .5, APS_BLACK)
PSLine(5.50, 0, 5.50, 80,  1, APS_BLACK)

Return 7

/*-----------------------------------------------------------------------------
Function ...: WaterMark() -> NIL
Description : Prints the watermark in the background of each page
Author .....: Stephan St-Denis
Date .......: April 2000
-----------------------------------------------------------------------------*/
Function WaterMark()

Local nOldUnit := PSGetUnit()

PSSetUnit(APS_MILL)

@140, 107 TEXTOUT "WATERMARK"  FONT APS_ARIAL  SIZE 36  STYLE APS_BOLD + APS_ITALIC  JUSTIFY APS_CENTER  COLOR APS_PALEGRAY

PSSetUnit(nOldUnit)

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeeGraphic()
Description : Using Abee PageScript capabilities to print good looking graphics
Author .....: Stephan St-Denis
Date .......: August 1999
-----------------------------------------------------------------------------*/
Static Function AbeeGraphic()

Local nLoop
Local nScale := 120000
Local nLine  := 68
Local aAmnt  := {72152, 55269, 117698, 92658, 69856, 19251, 115632, 98556, 94630, 72335, 31827, 5958}

PSBeginDoc(, "Graph test")

   PSFrame(25, 30, 190, 245, 4, APS_BLACK, APS_WHITE, APS_SOLID)
   PSLine(40, 60, 160, 60, 1, APS_BLACK)

   @30 ,140 TEXTOUT "Salesperson : Steve Von Denis" FONT APS_ARIAL;
            POINT 14  STYLE APS_BOLD  JUSTIFY APS_CENTER  COLOR APS_BLACK

   @170,140 TEXTOUT "Months" FONT APS_ARIAL;
            POINT 14  STYLE APS_BOLD  JUSTIFY APS_CENTER  COLOR APS_BLACK

   for nLoop := 40 to 160 step 10
      PSLine(nLoop, 58, nLoop, 235, 1, APS_BLACK)
      @nLoop-2,55 TEXTOUT TransForm(nScale, "999,999") + " $"  JUSTIFY APS_RIGHT  FONT APS_ARIAL
      nScale -= 10000
   next nLoop

   for nLoop := 1 to 12
      PSLine(160, nLine, 162, nLine, 1, APS_BLACK)
      @165,nLine TEXTOUT LTrim(Str(nLoop, 2, 0)) JUSTIFY APS_CENTER  FONT APS_ARIAL
      PSFrame(160, nLine - 3, CalcTop(aAmnt[nLoop]), nLine + 3, 1, APS_BLACK, -(nLoop + 1), APS_SOLID)
      nLine += 15
   next nLoop

ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeeText()
Description : Simulating a plain text report
Author .....: Stephan St-Denis
Date .......: August 1999
-----------------------------------------------------------------------------*/
Static Function AbeeText()

Local nRow
Local nPos
Local nWidth
Local S1 := 'This is a test to calculate'
Local S2 := 'the width of a string.'

PSBeginDoc(, "Simulating a plain text report")

PSSetUnit(APS_TEXT)
PSSetCPI(10)

PSTextOut(0, 0, '00000000001111111111222222222233333333334444444444555555555566666666667777777777')
PSTextOut(1, 0, '01234567890123456789012345678901234567890123456789012345678901234567890123456789')

for nRow := 3 to 6
   PSTextOut(nRow, 0, 'Text coordinate system. Printed at 10 CPI and 6 LPI (the defaults)')
next nRow

PSSetCPI(8)
PSTextOut( 8,  0, 'Testing at 8 CPI')

PSSetCPI(10)
PSTextOut( 9,  0, 'Testing at 10 CPI')

PSSetCPI(12)
PSTextOut(10,  0, 'Testing at 12 CPI')

PSSetCPI(15)
PSTextOut(11,  0, 'Testing at 15 CPI')

PSSetCPI(16)
PSTextOut(12,  0, 'Testing at 16 CPI (simulating condensed on certain printers)')

PSSetCPI(17)
PSTextOut(13,  0, 'Testing at 17 CPI (simulating condensed on certain printers)')

PSSetCPI(18)
PSTextOut(14,  0, 'Testing at 18 CPI')

PSSetCPI(20)
PSTextOut(15, 0, 'Testing at 20 CPI')

PSSetLPI(8)
PSSetCPI(10)
PSTextOut(22, 0, 'Now testing at 8 LPI and 10 CPI')
PSTextOut(23, 0, 'Now testing at 8 LPI and 10 CPI')

//PSSetFont(cFont, nStyle, nSize, nTFColor, nTBColor, nAngle)

PSSetFont('Arial',, 8)
PSTextOut(25, 0, 'You can also use proportional fonts when printing using text coordinates.')
PSTextOut(30, 45, 'Why not print at 90 degres !', , , , , , , , 90)

PSSetLPI(6)
PSLine(25, 39, 32, 39)

PSTextOut(25, 39, 'Text justification')
PSTextOut(26, 39, 'Left justify', , APS_LEFT)
PSTextOut(27, 39, 'Right justify', , APS_RIGHT)
PSTextOut(28, 39, 'Center justify', , APS_CENTER)

PSSetDecimalSep('.')
PSTextOut(29, 39, '9999.99 Justify on .', , APS_DECIMAL)

PSSetDecimalSep(',')
PSTextOut(30, 39, '9999,99 Justify on ,', , APS_DECIMAL)

PSSetDecimalSep('/')
PSTextOut(31, 39, '9999/99 Justify on /', , APS_DECIMAL)

// Calculating width for text positionning
PSSetFont(APS_COURIER)
PSSetCPI(10)
nPos   := 5
nWidth := PSGetTextWidth(S1)
PSTextOut(38, nPos, S1)
nPos := nPos + nWidth + 1
PSTextOut(38, nPos, S2)

PSSetCPI(20)
nPos   := 10
nWidth := PSGetTextWidth(S1)
PSTextOut(39, nPos, S1)
nPos := nPos + nWidth + 1
PSTextOut(39, nPos, S2)

PSSetCPI(10)
PSSetFont('Arial',, 8)
nPos   := 5
nWidth := PSGetTextWidth(S1)
PSTextOut(40, nPos, S1)
nPos := nPos + nWidth + 1
PSTextOut(40, nPos, S2)

PSSetFont(,, 10)
nPos   := 5
nWidth := PSGetTextWidth(S1)
PSTextOut(41, nPos, S1)
nPos := nPos + nWidth + 1
PSSetFont(APS_VERDANA,, 8)
nWidth := PSGetTextWidth(S2)
PSTextOut(41, nPos, S2)
nPos := nPos + nWidth + 1
PSSetFont(APS_TIMES,, 10)
PSTextOut(41, nPos, 'And you may mix fonts and sizes (not recommanded in text unit).')

PSEndDoc()

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeePixels()
Description : Printing using pixels coordinates
Author .....: Stephan St-Denis
Date .......: August 1999
-----------------------------------------------------------------------------*/
Static Function AbeePixels()

Local aCaps

BEGINDOC WITH 0  TITLE "Printing using pixel unit"  ORIENTATION APS_PORTRAIT
   aCaps := PSGetPrinterCaps()

	PSSetUnit(APS_PIXEL)
	PSFrame((aCaps[APC_AREAHEIGHT] / 2) - (aCaps[APC_VPIXELS] / 2), ;
           (aCaps[APC_AREAWIDTH]  / 2) - (aCaps[APC_VPIXELS] / 2), ;
	        (aCaps[APC_AREAHEIGHT] / 2) + (aCaps[APC_VPIXELS] / 2), ;
           (aCaps[APC_AREAWIDTH]  / 2) + (aCaps[APC_VPIXELS] / 2), ;
           1, APS_BLACK, APS_PALEGRAY)
	PSLine (0, 0, aCaps[APC_AREAHEIGHT], aCaps[APC_AREAWIDTH], 2, APS_BLACK) // Big X
	PSLine (aCaps[APC_AREAHEIGHT], 0, 0, aCaps[APC_AREAWIDTH], 2, APS_BLACK) // Big X
ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeeTextBox()
Description : Prints a long character string in a box region
Author .....: Stephan St-Denis
Date .......: March 2000

Function PSTextBox(nTop, nLeft, nBottom, nRight, cText, nJustify, cFont, nSize, ;
                   nStyle, nFColor, nBColor, nThick)

if slInitialized
   oPScript:TextBox(nTop, nLeft, nBottom, nRight, cText, nJustify, cFont, nSize, ;
                    nStyle, nFColor, nBColor, nThick)
endif

-----------------------------------------------------------------------------*/
Static Function AbeeTextBox()

Local cText := "This is a very long character string. It simulates a memo field and helps showing the capabilities of the PSTextBox() function available since PageScript version 2." + CRLF + CRLF + "*** THAT is a very long character string. It simulates a memo field and helps showing the capabilities of the PSTextBox() function available since PageScript version 2."

PSBeginDoc(, "Testing PSTextBox()", APS_PORTRAIT)

   PSSetUnit(APS_TEXT)   // Text coordinates
   PSSetCPI(17)

   @1 ,5 TEXTOUT "Left justified"   FONT APS_ARIAL  STYLE APS_BOLD  SIZE 10
   @11,5 TEXTOUT "Right justified"  FONT APS_ARIAL  STYLE APS_BOLD  SIZE 10
   @21,5 TEXTOUT "Center justified" FONT APS_ARIAL  STYLE APS_BOLD  SIZE 10

   PSTextBox( 2, 5, 10, 60, cText, APS_LEFT  , APS_COURIER,  8, APS_PLAIN , APS_BLACK, RGB(233, 197, 222), 0)
   PSTextBox(12, 5, 20, 60, cText, APS_RIGHT , APS_ARIAL  , 10, APS_BOLD  , APS_BLACK, RGB(173, 200, 187), 1)

   PSTextBox(22, 5, 30, 60, cText, APS_CENTER, APS_TIMES  , 12, APS_ITALIC, APS_BLACK, RGB(173, 176, 214), 2)
   PSTextBox( 2,75, 10, 95, cText, APS_LEFT  , APS_COURIER,  8, APS_PLAIN , APS_BLACK, RGB(233, 197, 222), 0)

   PSTextBox(12,75, 20, 95, cText, APS_RIGHT , APS_ARIAL  , 10, APS_BOLD  , APS_BLACK, RGB(173, 200, 187), 1)
   PSTextBox(22,75, 30, 95, cText, APS_CENTER, APS_TIMES  , 12, APS_ITALIC, APS_BLACK, RGB(173, 176, 214), 2)

   @32, 5 TO 40, 60  TEXTBOX cText  JUSTIFY APS_CENTER  FONT APS_SYSTEM  SIZE  16  COLOR APS_BLUE , APS_RED   THICKNESS 2
   @32, 75,  40, 95  TEXTBOX cText  JUSTIFY APS_CENTER  FONT APS_SYSTEM  SIZE  10  COLOR APS_BLACK, APS_BLUE  THICKNESS 1

PSEndDoc()

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeeBarCode()
Description : Show barcode capabilities
Author .....: Stephan St-Denis
Date .......: February 2000
-----------------------------------------------------------------------------*/
Static Function AbeeBarCode()

BEGINDOC WITH 0  TITLE "Printing barcodes"  ORIENTATION APS_PORTRAIT

	PSSetUnit(APS_TEXT)
	PSSetFont(APS_ARIAL, APS_PLAIN, 12)

   @0,20 TEXTOUT "Barcode Symbol 128B"    JUSTIFY APS_CENTER
   @0,60 TEXTOUT "Barcode Symbol 3 of 9"  JUSTIFY APS_CENTER

	PSSetUnit(APS_MILL)
   PSBarCode( 20, 20, "Barcode 128B"  , 24,  .5, .t., APS_BC128)
   PSBarCode( 20,120, "BARCODE 3 OF 9", 24,  .5, .t., APS_BC39)

   PSBarCode( 40, 20, "BarCode128"    , 24,  .5, .t., APS_BC128)
   PSBarCode( 60, 20, "BarCode128"    , 24, .75, .t., APS_BC128)
   PSBarCode( 80, 20, "BarCode128"    , 24,   1, .t., APS_BC128)

   PSBarCode( 40,120, "BarCode39"     , 24,  .5, .t., APS_BC39)
   PSBarCode( 60,120, "barcode39"     , 24, .75, .t., APS_BC39)
   PSBarCode( 80,120, "BARCODE39"     , 24,   1, .t., APS_BC39)

ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeePrinters()
Description : Station's available printers list
Author .....: Stephan St-Denis
Date .......: August 1999
-----------------------------------------------------------------------------*/
Static Function AbeePrinters()

Local nLoop
Local nRow      := 0
Local aPrinters := PSGetPrinters()

BEGINDOC WITH 0  TITLE "List of printers"  ORIENTATION APS_PORTRAIT
	PSSetUnit(APS_TEXT)
	PSSetFont(APS_ARIAL, APS_PLAIN, 12)

   for nLoop := 1 to Len(aPrinters)
      @nRow,5 TEXTOUT aPrinters[nLoop]
      if ++nRow > 50
         nRow := 0
         PSNewPage()
      endif
   next nLoop
ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeePaperBins()
Description : Station's available printers paper bin list
Author .....: Stephan St-Denis
Date .......: May 2006
-----------------------------------------------------------------------------*/
Static Function AbeePaperBins()

Local nLoop
Local nRow  := 3
Local aBins

aBins := PSGetPaperBins()

BEGINDOC WITH 0 TITLE "List of paper bins for the selected printer"  ORIENTATION APS_PORTRAIT
	PSSetUnit(APS_TEXT)
	PSSetRowCol(50, 80)
	PSSetFont(APS_ARIAL, APS_PLAIN, 12)

   @0,5 TEXTOUT "List of paper bins for the selected printer"

   for nLoop := 1 to Len(aBins)
      @nRow,5 TEXTOUT aBins[nLoop, 1] PICTURE "9999"
      @nRow,9 TEXTOUT aBins[nLoop, 2]
      if ++nRow > 45
         nRow := 3
         PSNewPage()
         @0,5 TEXTOUT "List of paper bins for the selected printer"
      endif
   next nLoop
ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeeFonts()
Description : List of available fonts for a specific printer
Author .....: Stephan St-Denis
Date .......: March 2000
-----------------------------------------------------------------------------*/
Static Function AbeeFonts()

Local nLoop
Local nRow      := 0
Local aFonts

BEGINDOC WITH 0  TITLE "List of available fonts"  ORIENTATION APS_PORTRAIT
   aFonts := aSort(PSGetFonts())

	PSSetUnit(APS_TEXT)
	PSSetFont(APS_ARIAL, APS_PLAIN, 8)

   for nLoop := 1 to Len(aFonts)
      @nRow,0  TEXTOUT aFonts[nLoop]
      @nRow,39 TEXTOUT aFonts[nLoop]  FONT aFonts[nLoop]
      PSLine(nRow + 1, 0, nRow + 1, 80, 1, APS_BLACK)
      if ++nRow > 56
         nRow := 0
         PSNewPage()
      endif
   next nLoop

ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeePointSize()
Description : Print the same string using different point size
Author .....: Stephan St-Denis
Date .......: March 2000
-----------------------------------------------------------------------------*/
Static Function AbeePointSize()

Local nLoop
Local nPoint    := 4

BEGINDOC WITH 0  TITLE "Point size test"  ORIENTATION APS_PORTRAIT
	PSSetUnit(APS_TEXT)
	PSSetFont(APS_ARIAL, APS_PLAIN, nPoint)

   for nLoop := 0 to 31
      @nLoop,0  TEXTOUT "This is printed at " + Str(nPoint, 5, 2) + " points." POINT nPoint
      nPoint += .25
   next nLoop

ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeePrnCaps
Description : List of supported printer caps as returned by PSGetCaps()
Author .....: Stephan St-Denis
Date .......: September 2000
-----------------------------------------------------------------------------*/
Static Function AbeePrnCaps()

Local nLoop
Local aCaps
Local aText := {;
   "Paper width :", ;
   "Paper height :", ;
   "Printable area width :", ;
   "Printable area height :", ;
   "Top margin :", ;
   "Left margin :", ;
   "Number of horizontal pixels per inch :", ;
   "Number of vertical pixels per inch :", ;
   "Number of bits per pixel (1 = B&W) :"}

PSBeginDoc(, "Selected printer capabilities", APS_PORTRAIT)
	PSSetUnit(APS_TEXT)
	PSSetFont(APS_ARIAL, APS_PLAIN, 10)

   aCaps := PSGetPrinterCaps()

   @0, 39 TEXTOUT "Capabilities of " + PSGetPrinters()[PSGetPrinter()] JUSTIFY APS_CENTER  STYLE APS_BOLD  POINT 14

   for nLoop := 1 to Len(aCaps)
      @nLoop + 5, 30 TEXTOUT aText[nLoop] JUSTIFY APS_RIGHT
      @nLoop + 5, 31 TEXTOUT aCaps[nLoop]
   next nLoop

ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function ...: CalcTop(<n>) -> nTopCoor
Description : Calculates the top coor. of a bar
Author .....: Stephan St-Denis
Date .......: August 1999
-----------------------------------------------------------------------------*/
Static Function CalcTop(nAmnt)

Return 160 - (nAmnt / 1000)

/*-----------------------------------------------------------------------------
Function ...: AbeeConvert()
Description : Print a string with and without Ascii to Ansi convertion
Author .....: Stephan St-Denis
Date .......: March 2001
-----------------------------------------------------------------------------*/
Static Function AbeeConvert()

Local nLoop

BEGINDOC WITH 0  TITLE "Ascii to Ansi convertion test"  ORIENTATION APS_PORTRAIT
	PSSetUnit(APS_TEXT)
	PSSetFont(APS_COURIER, APS_PLAIN, 10)

   @0,0  TEXTOUT "Converted"
   @0,40 TEXTOUT "Not converted"

   for nLoop := 1 to 42
      PSSetAsciiToAnsi(.t.)
      @nLoop + 1,  0 TEXTOUT Str(nLoop + 127, 3, 0) + " = " + Chr(nLoop + 127)
      @nLoop + 1, 10 TEXTOUT Str(nLoop + 169, 3, 0) + " = " + Chr(nLoop + 169)
      @nLoop + 1, 20 TEXTOUT Str(nLoop + 211, 3, 0) + " = " + Chr(nLoop + 211)

      PSSetAsciiToAnsi(.f.)
      @nloop + 1, 40 TEXTOUT Str(nLoop + 127, 3, 0) + " = " + Chr(nLoop + 127)
      @nLoop + 1, 50 TEXTOUT Str(nLoop + 169, 3, 0) + " = " + Chr(nLoop + 169)
      @nLoop + 1, 60 TEXTOUT Str(nLoop + 211, 3, 0) + " = " + Chr(nLoop + 211)
   next nLoop

ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeeConvert()
Description : Print a string with and without Ascii to Ansi convertion
Author .....: Stephan St-Denis
Date .......: March 2001
-----------------------------------------------------------------------------*/
Static Function AbeeDuplex()

Local nLoop
Local nCopies

BEGINDOC WITH 0 TITLE "Duplex mode test"  ORIENTATION APS_PORTRAIT
	PSSetUnit(APS_TEXT)
	PSSetFont(APS_COURIER, APS_PLAIN, 10)

   for nCopies := 1 to 2
      for nLoop := 1 to 25
         @nLoop, 10 TEXTOUT "This is a Duplex test"
      next nLoop

      if nCopies < 2
         PSNewPage()
      endif
   next nCopies
ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeeLegal()
Description : Print on a LEGAL paper size format
Author .....: Stephan St-Denis
Date .......: May 2001
-----------------------------------------------------------------------------*/
Static Function AbeeLegal()

Local nLoop
Local nMax

PSSetPageSize(DMPAPER_LEGAL)

if PSPrintDialog()
   BEGINDOC WITH 0  TITLE "Printing on Legal format"
	PSSetUnit(APS_TEXT)
   PSSetCPI(10)
   PSSetLPI(6)
	PSSetFont(APS_COURIER, APS_PLAIN, 12)

   nMax := Int(PSGetMaxHeight()) - 1

   @0,  0 TEXTOUT "This is the first line"
   @0, 29 TEXTOUT "This is the first line"
   @0, 58 TEXTOUT "This is the first line"

   for nLoop := 1 to nMax - 1
      @nLoop,  0 TEXTOUT "This is a test"
      @nLoop, 29 TEXTOUT "This is a test"
      @nLoop, 58 TEXTOUT "This is a test"
   next nLoop

   @nMax,  0 TEXTOUT "This is the last line"
   @nMax, 29 TEXTOUT "This is the last line"
   @nMax, 58 TEXTOUT "This is the last line"

   ENDDOC
endif

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeeRawData()
Description : Prints RAW data
Author .....: Stephan St-Denis
Date .......: May 2001
-----------------------------------------------------------------------------*/
Static Function AbeeRAWData()

Local nRow := 0
Local nModel

Scroll(4, 0, 23, 79, 0)
@4,2 to 8, 28
@5,46 say "Please select a printer brand"
@6,46 say "to send raw data."

if (nModel := AChoice(5, 4, 20, 26, {"Compatible HP LaserJet", "Compatible IBM Graphics", "Compatible Epson LQ"})) == 0
   Return NIL
endif

SetPrinterCodes(nModel + 1)

PSBeginRawDoc(0, "RAW data")

// USING @SAY
@nRow,0  say "Printing using @SAY"
nRow += 2

@nRow  ,0 say "Basic styles"
nRow += 2

@nRow++,0 say PC(PC_BOLDON)   + "This line is printed in bold" + PC(PC_BOLDOFF)
@nRow  ,0 say PC(PC_ITALICON) + "This line is printed in italic" + PC(PC_ITALICOFF)
nRow += 2

@nRow  ,0 say "Mixed styles"
nRow += 2

@nRow  ,0 say PC(PC_BOLDON)   + "Printed using bold  " + PC(PC_ITALICON) + "and italic" + PC(PC_ITALICOFF) + PC(PC_BOLDOFF)
nRow += 2

@nRow  ,0 say "Font size (CPI)"
nRow += 2

@nRow++,0 say PC(PC_SET17CPI) + "17 CPI " + Repl("X", 125)  // 17 CPI
@nRow  ,0 say PC(PC_SET10CPI) + "10 CPI " + Repl("X",  73)  // 10 CPI
nRow += 2

@nRow  ,0 say "IBM Character set II Test - (may not print on your printer)"
nRow += 2

@nRow  ,0 say ""

EJECT

// USING ? / ??
?? "Printing using ? / ?? (QOut / QQOut)" + CRLF2
?? "Basic styles"  + CRLF2
?? PC(PC_BOLDON)   + "This line is printed in bold" + PC(PC_BOLDOFF) + CRLF
?? PC(PC_ITALICON) + "This line is printed in italic" + PC(PC_ITALICOFF) + CRLF2

?? "Mixed styles"  + CRLF2
?? PC(PC_BOLDON)   + "Printed using bold  " + PC(PC_ITALICON) + "and italic" + PC(PC_ITALICOFF) + PC(PC_BOLDOFF) + CRLF2

?? "Font size (CPI)" + CRLF2
?? PC(PC_SET17CPI) + "17 CPI " + Repl("X", 125) + CRLF  // 17 CPI
?? PC(PC_SET10CPI) + "10 CPI " + Repl("X",  73) + CRLF2 // 10 CPI

?? "IBM Character set II Test - (may not print on your printer)" + CRLF2

?? ""

EJECT

PSEndRawDoc()

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeeEmuData()
Description : Prints using the EMULATION mode
Author .....: Stephan St-Denis
Date .......: May 2001
-----------------------------------------------------------------------------*/
Static Function AbeeEMUData()

SetPrinterCodes(1)

PSBeginEmuDoc(0, "EMULATION mode")

@ 0,0  say "Basic styles"
@ 2,0  say PC(PC_BOLDON)   + "This line is printed in bold" + PC(PC_BOLDOFF)
@ 3,0  say PC(PC_ITALICON) + "This line is printed in italic" + PC(PC_ITALICOFF)
@ 4,0  say PC(PC_UNDERON)  + "This line is underlined" + PC(PC_UNDEROFF)
@ 5,0  say PC(PC_STRIKEON) + "This line is striked out" + PC(PC_STRIKEOFF)

@ 7,0  say "Mixed styles"
@ 9,0  say PC(PC_BOLDON)   + "Printed using bold " + PC(PC_STRIKEON) + "and strikeout" + PC(PC_STRIKEOFF) + PC(PC_BOLDOFF)
@10,0  say PC(PC_ITALICON) + "Let's start printing using italic"
@11,0  say PC(PC_UNDERON)  + "and continue by adding underline"
@12,0  say PC(PC_BOLDON)   + "and why not adding bold" + PC(PC_BOLDOFF) + PC(PC_UNDEROFF) + PC(PC_ITALICOFF)

@14,0  say "Font size (CPI)"
@16,0  say PC(PC_SET8CPI)  + "08 CPI " + Repl("X",  57)  // 8  CPI
@17,0  say PC(PC_SET10CPI) + "10 CPI " + Repl("X",  73)  // 10 CPI
@18,0  say PC(PC_SET12CPI) + "12 CPI " + Repl("X",  89)  // 12 CPI
@19,0  say PC(PC_SET15CPI) + "15 CPI " + Repl("X", 113)  // 15 CPI
@20,0  say PC(PC_SET17CPI) + "17 CPI " + Repl("X", 125)  // 17 CPI
@21,0  say PC(PC_SET18CPI) + "18 CPI " + Repl("X", 137)  // 18 CPI
@22,0  say PC(PC_SET20CPI) + "20 CPI " + Repl("X", 153)  // 20 CPI

EJECT

?? PC(PC_SET10CPI) + "Line spacing (8 LPI)" + CRLF2
?? PC(PC_SET8LPI)  + "Line spacing = 8 LPI" + Repl("X",  50) + CRLF  // 8 LPI
?? "Line spacing = 8 LPI" + Repl("X",  50) + CRLF
?? "Line spacing = 8 LPI" + Repl("X",  50)

EJECT

?? "Line spacing (6 LPI)" + CRLF2
?? PC(PC_SET6LPI)  + "Line spacing = 6 LPI" + Repl("X",  50) + CRLF  // 6 LPI
?? "Line spacing = 6 LPI" + Repl("X",  50) + CRLF
?? "Line spacing = 6 LPI" + Repl("X",  50) + CRLF2
?? "Everything back to normal"

PSEndEmuDoc()

Return NIL

/*-----------------------------------------------------------------------------
Function ...: AbeeAutoTextCoor()
Description :
Author .....: Stephan St-Denis
Date .......: April 2006
-----------------------------------------------------------------------------*/
Static Function AbeeAutoTextCoor()

PSBeginDoc(0, "Default text coordinates test")
PSSetUnit(APS_TEXT)
PSSetCPI(10)
PSSetLPI(6)
PSSetFont(APS_COURIER, APS_PLAIN, 12)

/*
Function PSTextOut(nTop, nLeft, xValue, cPicture, nJustify, cFont, nSize, nStyle, nTFColor, nTBColor, nAngle)
*/

PSTextOut( , , "This is a test "  , , , APS_VERDANA,  9)
PSTextOut( , , "using different " , , , APS_ARIAL  , 10, APS_BOLD)
PSTextOut( , , "styles "          , , , APS_TIMES  , 10, APS_ITALIC)
PSTextOut( , , "and fonts "       , , , APS_VERDANA,  9, APS_BOLD + APS_ITALIC)
PSTextOut( , , "on the same line.", , , APS_ARIAL  , 10)

ENDDOC

Return NIL

/*-----------------------------------------------------------------------------
Function .: #PC(<n>, <c>)
Fonction .: Get/Set the printer codes
Author ...: Stephan St-Denis
Date .....: October 2002
-----------------------------------------------------------------------------*/
Function PC(nCode, cCode)

Static aPC := {"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""}

if ValType(cCode) == "C"
   aPC[nCode] := cCode
endif

Return aPC[nCode]

/*-----------------------------------------------------------------------------
Function .: #SetPrinter()
Fonction .: Sets the printer codes
Author ...: Stephan St-Denis
Date .....: October 2002
-----------------------------------------------------------------------------*/
Function SetPrinterCodes(nRecNo)

USE PRINTERS

dbGoto(nRecNo)

PC(PC_BOLDON   , CtoEsc(field->boldon)   )
PC(PC_BOLDOFF  , CtoEsc(field->boldoff)  )
PC(PC_ITALICON , CtoEsc(field->italicon) )
PC(PC_ITALICOFF, CtoEsc(field->italicoff))
PC(PC_UNDERON  , CtoEsc(field->underon)  )
PC(PC_UNDEROFF , CtoEsc(field->underoff) )
PC(PC_STRIKEON , CtoEsc(field->strikeon) )
PC(PC_STRIKEOFF, CtoEsc(field->strikeoff))
PC(PC_SET8CPI  , CtoEsc(field->set8cpi)  )
PC(PC_SET10CPI , CtoEsc(field->set10cpi) )
PC(PC_SET12CPI , CtoEsc(field->set12cpi) )
PC(PC_SET15CPI , CtoEsc(field->set15cpi) )
PC(PC_SET17CPI , CtoEsc(field->set17cpi) )
PC(PC_SET18CPI , CtoEsc(field->set18cpi) )
PC(PC_SET20CPI , CtoEsc(field->set20cpi) )
PC(PC_SET6LPI  , CtoEsc(field->set6lpi)  )
PC(PC_SET8LPI  , CtoEsc(field->set8lpi)  )

dbCloseArea()

Return NIL

/*-----------------------------------------------------------------------------
Function .: #CtoEsc(<c>) -> cEscapedCode
Fonction .: Convert a string in the form of \nnn + \nnn ... to real escape codes
Author ...: Stephan St-Denis
Date .....: October 2002
-----------------------------------------------------------------------------*/
Function CtoEsc(cIn)

Local cOut   := ""
Local nAscii := 0
Local nLoop  := 0

for nLoop := 1 to Len(cIn)
   if SubStr(cIn, nLoop, 1) == "\"   // C'est un code \nnn (ascii)
      nAscii := Val(SubStr(cIn, nLoop + 1, 3))
      if ValType(nAscii) == "N"
         if nAscii > 255
            nAscii := 32
         endif
      else
         nAscii := 32
      endif

      cOut  += Chr(nAscii)
      nLoop += 3

      if nLoop > Len(cIn)
         exit
      endif
   else
      cOut += SubStr(cIn, nLoop, 1)  // C'est un caractre tel quel
   endif
next nLoop

Return AllTrim(cOut)

* ---------

Function SelectDevice( nChoice )

Local aDevices  := ;
   {"Printer", ;
    "Print preview", ;
    "PDF File"}

Local nDevice   := 0
LOCAL GetList[0], i, nRow := 0

IF nChoice >= 24
  AAdd(aDevices,"Preview w/Acrobat")
ENDIF

FOR i := 1 TO Len(aDevices)
  @ nRow,0 DCPUSHBUTTONXP CAPTION aDevices[i] SIZE 30,1 ;
        ACTION DeviceBlock(GetList,i,@nDevice) ;
        GRADIENT 5 RADIUS 15;
        COLOR COLOR_WHITE,  COLOR_DARKPINK ;
        MOUSECOLOR  COLOR_BLACK, COLOR_LTORANGE ;
        SELECTCOLOR COLOR_BLACK, COLOR_ORANGE
  nRow += 1.1
NEXT

DCREAD GUI FIT TITLE 'Select a Device' MODAL

Return nDevice

* ---------

STATIC FUNCTION DeviceBlock( GetList, i, nDevice )

RETURN {||nDevice := i, DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

* ---------

STATIC FUNCTION ExpressStylePrint1(nDevice)

LOCAL i, j, cPict := '@!', cFont := '10.Lucida Console Bold', nFG, nBG
Local nRow     := 7
Local nPage    := 1
Local cText := "This is a very long character string. It simulates a memo field and helps showing the capabilities of the PSTextBox() function available since PageScript version 2." + CRLF + CRLF + "*** THAT is a very long character string. It simulates a memo field and helps showing the capabilities of the PSTextBox() function available since PageScript version 2."

DCPS ON TITLE "Customer list" ORIENTATION 1 PAGESIZE DMPAPER_LETTER ;
        FONT cFont _ACROBAT nDevice==4 _XPSWRITER nDevice==5

// Page 1

@ 0,0,63,82 DCPS FRAME THICKNESS 2 BORDERCOLOR GRA_CLR_RED FILLCOLOR {240,240,240}

FOR j := 0 TO 40 STEP 40
  IF j == 40
    DCPS FONT '11.Arial Italic'
  ENDIF
  FOR i := 1 TO 60
    IF i%2 == 0
      nFG := IIF(j==40,GRA_CLR_DARKRED,GRA_CLR_DARKGREEN)
      nBG := IIF(j==40,NIL,{ 200,200,200 })
    ELSE
      nFG := nBG := NIL
    ENDIF
    @ i+1,j+5 DCPS SAY 'This is a line of Text - Line ' + Alltrim(Str(i)) ;
            COLOR nFG, nBG
  NEXT
NEXT

DCPS NEWPAGE

// Page 2

use customer exclusive

DCPS FONT '12.Courier New'

nRow := CustHeader(nPage)

DO WHILE !Eof()

  @ nRow,   0 DCPS SAY field->custno
  @ nRow,  11 DCPS SAY field->name
  @ nRow+1,11 DCPS SAY field->address1
  @ nRow+2,11 DCPS SAY field->address2
  @ nRow+3,11 DCPS SAY field->address3
  @ nRow,  51 DCPS SAY field->phone PICTURE "@R (999) 999-9999"
  @ nRow+1,51 DCPS SAY field->fax PICTURE "@R (999) 999-9999"
  @ nRow,  78 DCPS SAY field->due PICTURE "999,999,999.99" ALIGN APS_DECIMAL

  @ nRow + 4.5, 0, nRow + 4.5, 80 DCPS LINE WIDTH .5 COLOR GRA_CLR_DARKGREEN

  nRow += 5

  IF nRow > 58
    DCPS NEWPAGE
    nPage++
    nRow := CustHeader(nPage)
  ENDIF

  dbSkip()

ENDDO

dbCloseAll()

// Page 5

DCPS NEWPAGE

PSSetCPI(17)

@  1,5 DCPS SAY "Left justified" FONT '10.Arial Bold'
@ 11,5 DCPS SAY "Right justified" FONT '10.Arial Bold'
@ 21,5 DCPS SAY "Center justified" FONT '10.Arial Bold'

@  2, 5, 10, 60 DCPS TEXTBOX cText ALIGN APS_LEFT FONT '8.Courier New' COLOR GRA_CLR_BLACK, {233, 197, 222} THICK 0

@ 12, 5, 20, 60 DCPS TEXTBOX cText ALIGN APS_RIGHT FONT '10.Arial Bold' COLOR GRA_CLR_BLACK, {173, 200, 187} THICK 1

@ 22, 5, 30, 60 DCPS TEXTBOX cText ALIGN APS_CENTER FONT '12.Times New Roman Italic' COLOR GRA_CLR_BLACK, {173, 176, 214} THICK 2
@  2,75, 10, 95 DCPS TEXTBOX cText ALIGN APS_LEFT FONT '8.Courier New' COLOR GRA_CLR_BLACK, {233, 197, 222} THICK 0

@ 12,75, 20, 95 DCPS TEXTBOX cText ALIGN APS_RIGHT FONT '10.Arial Bold' COLOR GRA_CLR_BLACK, {173, 200, 187} THICK 1
@ 22,75, 30, 95 DCPS TEXTBOX cText ALIGN APS_CENTER FONT '12.Times New Roman Italic' COLOR GRA_CLR_BLACK, {173, 176, 214} THICK 2

@ 32, 5, 40, 60 DCPS TEXTBOX cText ALIGN APS_CENTER FONT '16.Courier New' COLOR GRA_CLR_DARKBLUE, GRA_CLR_DARKRED THICKNESS 2
@ 32,75, 40, 95 DCPS TEXTBOX cText ALIGN APS_CENTER FONT '10.Courier New' COLOR GRA_CLR_BLACK, GRA_CLR_DARKBLUE THICKNESS 1

DCPS UNITS APS_MILL

@180, 10 DCPS SAY "Natural size"
@180, 50 DCPS SAY "Stretched"
@180,100 DCPS SAY "Calculated Width"
@210,143 DCPS SAY "Calculated Height" ANGLE 90

@ 185, 10, 0, 0 DCPS BITMAP "LOGOABEE.BMP" // Natural size
@ 185, 50, 195, 80 DCPS BITMAP "LOGOABEE.BMP" // Stretch
@ 185, 100, 215, 0 DCPS BITMAP "PS4.JPG"      // Calculated Width
@ 185, 150, 0, 180 DCPS BITMAP "PS4.JPG"      // Calculated Height

@ 218, 10, 218, 190 DCPS LINE THICKNESS 1 COLOR GRA_CLR_BLACK

DCPS OFF

RETURN nil

* ------------

FUNCTION ExpressStylePrint2(nDevice)

Local nLoop
Local cText := ;
  "Paradise is engineered on Vos, the hidden sister planet of Earth that " + ;
  "orbits the sun directly opposite our own planet; sirens and satyrs dance " + ;
  "to the music of love and bounty; the seer arrives to warn of the approaching " + ;
  "Dark and is ignored. Los the Irrational attempts to stifle the music; " + ;
  "the sirens and satyrs are concerned, but are too apathetic to act; the music " + ;
  "wheel on which Vos rotates grinds to a halt; the birds and insects leave " + ;
  "Paradise; the Darkness begins. Many sirens and satyrs perish in the frigid " + ;
  "Darkness; Emau stumbles across a hollow reed in the forests and creates music; " + ;
  "Los the Irrational battles Emau with Silence; Emau triumphs; light returns to Paradise."

DCPS ON TITLE "Bill of Lading" ORIENTATION 1 PAGESIZE DMPAPER_LETTER ;
        _ACROBAT nDevice==4 _XPSWRITER nDevice==5

DCPS UNITS APS_MILL

// Puro Logo
@ 15, 8, 22, 50 DCPS BITMAP "PUROLOGO.BMP"

// Top/Left Two frames
@ 25, 8,  62, 100 DCPS FRAME THICKNESS 2 FILLCOLOR GRA_CLR_WHITE
@ 65, 8, 112, 100 DCPS FRAME THICKNESS 2 FILLCOLOR GRA_CLR_WHITE

@ 27, 55 DCPS SAY "SENDER (FROM)"          FONT '8.Arial' JUSTIFY APS_CENTER
@ 33, 10 DCPS SAY "AbeeLabs Systems Inc."  FONT '8.Arial Bold'
@ 37, 10 DCPS SAY "70, de la Gare Street"  FONT '8.Arial Bold'
@ 42, 10 DCPS SAY "St. Jerome, Quebec"     FONT '8.Arial Bold'
@ 51, 10 DCPS SAY "J7Z 2B8"                FONT '8.Arial Bold'
@ 56, 10 DCPS SAY "(999) 555-5555"         FONT '8.Arial Bold'

@ 67, 55 DCPS SAY "RECEIVER (TO)"          FONT '10.Arial' JUSTIFY APS_CENTER
@ 72, 10 DCPS SAY "Liza Peabody"           FONT '14.Arial Bold'
@ 78, 10 DCPS SAY "Mistral Floors Ltd."    FONT '14.Arial Bold'
@ 84, 10 DCPS SAY "2211, Industrial blvd." FONT '14.Arial Bold'
@ 95, 10 DCPS SAY "Springfield, Ill 24551" FONT '14.Arial Bold'
@101, 10 DCPS SAY "(888) 555-1111"         FONT '14.Arial Bold'

@ 10,112 DCPS SAY "PACKAGE I.D. NO."       FONT '8.Arial'
@  8,143 DCPS SAY "7 0 3  8 2 3  8 7 3 4"  FONT '16.Arial Bold'
@ 18,60  DCPS SAY "0 1 5 1 8 1 6 9 6"      FONT '14.Arial Bold'
@ 25,120 DCPS SAY "BILL CHARGES TO"        FONT '8.Arial' JUSTIFY APS_CENTER
@ 25,145 DCPS SAY "TOTAL WEIGHT"           FONT '8.Arial' JUSTIFY APS_CENTER
@ 25,170 DCPS SAY "PIECES"                 FONT '8.Arial' JUSTIFY APS_CENTER
@ 25,192 DCPS SAY "DATE"                   FONT '8.Arial' JUSTIFY APS_CENTER

@ 29,145 DCPS SAY "SUBJECT TO AUDIT"       FONT '6.Arial' JUSTIFY APS_CENTER
@ 29,192 DCPS SAY "MO  DAY  YEAR"          FONT '6.Arial' JUSTIFY APS_CENTER

@ 34,120 DCPS SAY "RECEIVER"               FONT '10.Arial Bold' JUSTIFY APS_CENTER
@ 34,145 DCPS SAY "1 POUND"                FONT '10.Arial Bold' JUSTIFY APS_CENTER
@ 34,170 DCPS SAY "1 OF 1"                 FONT '10.Arial Bold' JUSTIFY APS_CENTER
@ 34,192 DCPS SAY Date()                   FONT '10.Arial Bold' JUSTIFY APS_CENTER

@ 45,155 DCPS SAY "SERVICE OPTIONS"        FONT '11.Arial Bold Italic' JUSTIFY APS_CENTER

@109,135 DCPS SAY "PIN"                    FONT '6.Arial' JUSTIFY APS_CENTER
@108,160 DCPS SAY "7 0 3  8 2 3  8 7 3 4"  FONT '10.Arial' JUSTIFY APS_CENTER

@115, 14 DCPS SAY "UNICODE"                FONT '6.Arial' JUSTIFY APS_CENTER
@115, 60 DCPS SAY "AIRPORT CODE"           FONT '6.Arial' JUSTIFY APS_CENTER
@115, 95 DCPS SAY "SERVICE GARANTEE"       FONT '6.Arial' JUSTIFY APS_CENTER

@125, 14 DCPS SAY "32"                     FONT '36.Arial Bold' JUSTIFY APS_CENTER
@141,205 TEXTOUT "45333 4.0000426033411"  FONT APS_ARIAL  SIZE 6 JUSTIFY APS_RIGHT

@141,205 DCPS SAY "45333 4.0000426033411"  FONT '6.Arial' JUSTIFY APS_RIGHT

@143,  8 DCPS SAY "Fold this Bill of Lading on the dotted line and insert it into the labelope. Attach a Bill of Lading to each package." ;
                                             FONT '8.Arial Bold'
PSBarCode(112, 110, "A7038238734", 64, 1, .f., APS_BC39)

FOR nLoop := 8 to 205 step 2
  @ 140, nLoop, 140, nLoop + 1 DCPS LINE THICKNESS 1
NEXT nLoop

@157,  8 DCPS SAY "Description :"          FONT '8.Arial Bold'

@ 160, 27, 160, 115 DCPS LINE THICKNESS 1

@162,  8 DCPS SAY "No Declared Value Entered in Software By Sender" FONT '8.Arial Bold'

@176,107 DCPS SAY "TRANSPORTATION CONDITIONS"  FONT '8.Arial Bold' JUSTIFY APS_CENTER

@180, 8, 192, 205 DCPS TEXTBOX "1)  " + cText  FONT '7.Arial' THICKNESS 0
@193, 8, 205, 205 DCPS TEXTBOX "2)  " + cText  FONT '7.Arial' THICKNESS 0
@206, 8, 212, 205 DCPS TEXTBOX "3)  " + cText  FONT '7.Arial' THICKNESS 0
@213, 8, 216, 205 DCPS TEXTBOX "4)  " + cText  FONT '7.Arial' THICKNESS 0
@218, 8, 230, 205 DCPS TEXTBOX "5)  " + cText  FONT '7.Arial' THICKNESS 0
@231, 8, 238, 205 DCPS TEXTBOX "6)  " + cText  FONT '7.Arial' THICKNESS 0
@239, 8, 254, 205 DCPS TEXTBOX "7)  " + cText  FONT '7.Arial' THICKNESS 0

DCPS OFF

RETURN nil

* -----------

Function ExpressStylePrint3(nDevice)

dbSelectArea(dbINV_DETAIL)
use InvDetai exclusive

dbSelectArea(dbINV_MASTER)
use InvMaste exclusive

DCPS ON TITLE "Abee invoice" ORIENTATION APS_PORTRAIT ;
        _ACROBAT nDevice==4 _XPSWRITER nDevice==5

DCPS UNITS APS_MILL

PSSetDecimalSep(".")

// Default unit = milimeters
@ 10, 140, 20, 200 DCPS FRAME THICKNESS 0 FILLCOLOR GRA_CLR_PALEGRAY
@ 25, 155, 35, 190 DCPS FRAME THICKNESS 0 FILLCOLOR GRA_CLR_PALEGRAY

// WARNING : Make sure that this is a valid path
@ 10, 10, 32, 85 DCPS BITMAP "\" + CurDir() + "\LOGOABEE.BMP" KEEPRATIO

@ 73, 10,  80, 206 DCPS FRAME THICKNESS 0 FILLCOLOR GRA_CLR_PALEGRAY
@ 86, 10,  92, 206 DCPS FRAME THICKNESS 0 FILLCOLOR GRA_CLR_PALEGRAY
@ 99, 10, 105, 206 DCPS FRAME THICKNESS 0 FILLCOLOR GRA_CLR_PALEGRAY
@215, 10, 265, 130 DCPS FRAME THICKNESS 0 FILLCOLOR GRA_CLR_PALEGRAY

@ 73, 10,  73, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_DARKBLUE
@ 80, 10,  80, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@ 86, 10,  86, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@ 92, 10,  92, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@ 99, 10,  99, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@105, 10, 105, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@215, 10, 215, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@265, 10, 265, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK

@215,  130, 215, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@223,  130, 223, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@231,  130, 231, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@240,  130, 240, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@248,  130, 248, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@257,  130, 257, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK

@215,  130, 265, 130 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@215,  169, 265, 169 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK

@ 73,   10, 265,  10 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@ 73,  206, 265, 206 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK

@ 73,   30,  86,  30 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@ 73,   70,  86,  70 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@ 73,  124,  86, 124 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@ 73,  165,  86, 165 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK

@ 86,   81,  99,  81 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@ 86,  125,  99, 125 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@ 86,  156,  99, 156 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@ 86,  177,  99, 177 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK

@ 99,  123, 105, 123 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@ 99,  151, 105, 151 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK
@ 99,  179, 105, 179 DCPS LINE THICKNESS .5 COLOR GRA_CLR_BLACK

PSSetFont(APS_TIMES,, 8, APS_BLACK)
@ 12,170 DCPS SAY "INVOICE"            JUSTIFY APS_CENTER  FONT '14.Arial Bold'
@ 28,158 DCPS SAY "No"
@ 13,90  DCPS SAY "Working"
@ 16,90  DCPS SAY "like bees,"
@ 19,90  DCPS SAY "to bring you"
@ 22,90  DCPS SAY "the best software."
@ 33,50  DCPS SAY "70, de la Gare Street, St.Jerome, (Quebec), Canada, J7Z 2B8"  JUSTIFY APS_CENTER
@ 36,50  DCPS SAY "Phone: 555 555-5555 - Fax: (555) 555-5550"                    JUSTIFY APS_CENTER

PSSetFont(APS_ARIAL,, 7)
@ 75, 20 DCPS SAY "CUSTOMER #"         JUSTIFY APS_CENTER
@ 75, 52 DCPS SAY "PURCHASE ORDER #"   JUSTIFY APS_CENTER
@ 75, 98 DCPS SAY "SHIP VIA"           JUSTIFY APS_CENTER
@ 75,145 DCPS SAY "PHONE #"            JUSTIFY APS_CENTER
@ 75,185 DCPS SAY "FAX #"              JUSTIFY APS_CENTER

@ 88, 45 DCPS SAY "SALESPERSON"        JUSTIFY APS_CENTER
@ 88,103 DCPS SAY "TERMS"              JUSTIFY APS_CENTER
@ 88,140 DCPS SAY "DATE"               JUSTIFY APS_CENTER
@ 88,167 DCPS SAY "OUR ORDER #"        JUSTIFY APS_CENTER
@ 88,191 DCPS SAY "SHIP DATE"          JUSTIFY APS_CENTER

@101, 75 DCPS SAY "DESCRIPTION"        JUSTIFY APS_CENTER
@101,138 DCPS SAY "QTY"                JUSTIFY APS_CENTER
@101,165 DCPS SAY "UNIT PRICE"         JUSTIFY APS_CENTER
@101,192 DCPS SAY "EXTENSION"          JUSTIFY APS_CENTER

@218,150 DCPS SAY "SUB-TOTAL"          JUSTIFY APS_CENTER
@226,150 DCPS SAY "SALES TAX 1"        JUSTIFY APS_CENTER
@234,150 DCPS SAY "SALES TAX 2"        JUSTIFY APS_CENTER
@243,150 DCPS SAY "TOTAL"              JUSTIFY APS_CENTER
@252,150 DCPS SAY "AMOUNT RECEIVED"    JUSTIFY APS_CENTER
@260,150 DCPS SAY "BALANCE DUE"        JUSTIFY APS_CENTER

InvoiceHeader()  // Print the header
InvoiceDetail()  // Print the detail
InvoiceTotal()   // Print the total

DCPS OFF

dbCloseAll()

Return NIL

* ------------

Function ExpressStylePrint4(nDevice)

Local nLoop
Local nPoint := 4

wtf nDevice pause

DCPS BEGINDOC TITLE "Point size test"  ORIENTATION APS_PORTRAIT ;
   _ACROBAT nDevice==4 _XPSWRITER nDevice==5

DCPS FONT '4.Arial'

FOR nLoop := 0 to 25
   @ nLoop,0 DCPS SAY "This is printed at " + Str(nPoint, 5, 2) + " points." POINT nPoint
   nPoint += .25
NEXT

FOR nLoop := 26 to 50
   @ nLoop,0 DCPS SAY "This is printed at " + Str(nPoint, 5, 2) + " points. (Italic)" POINT nPoint ;
      STYLE APS_ITALIC
   nPoint += .25
NEXT

@ 53, 2 DCPS BARCODE "Barcode 128B" HEIGHT 24 THICKNESS .5 PRINTTEXT TYPE APS_BC128
@ 56, 2 DCPS BARCODE "BARCODE 3 OF 9" HEIGHT 24 THICKNESS .5 PRINTTEXT TYPE APS_BC39

@ 53, 30 DCPS BARCODE "BarCode128" HEIGHT 24 THICKNESS .5 PRINTTEXT TYPE APS_BC128
@ 56, 30 DCPS BARCODE "BarCode128" HEIGHT 24 THICKNESS .75 PRINTTEXT TYPE APS_BC128
@ 59, 30 DCPS BARCODE "BarCode128" HEIGHT 24 THICKNESS 1 PRINTTEXT TYPE APS_BC128

@ 53, 60 DCPS BARCODE "BarCode39" HEIGHT 24 THICKNESS .5 PRINTTEXT TYPE APS_BC39
@ 56, 60 DCPS BARCODE "barcode39" HEIGHT 24 THICKNESS .75 PRINTTEXT TYPE APS_BC39
@ 59, 60 DCPS BARCODE "BARCODE39" HEIGHT 24 THICKNESS 1 PRINTTEXT TYPE APS_BC39

DCPS ENDDOC

Return NIL

* --------

FUNCTION ExpressStylePrint5(nDevice)

Local nLoop

DCPS BEGINDOC _ACROBAT nDevice==4 _XPSWRITER nDevice==5

FOR nLoop := APS_SOLID to APS_VERTICAL

  @0, (nLoop * 10), 15, (nLoop * 10) + 10  DCPS FRAME THICKNESS .5 ;
      BORDERCOLOR GRA_CLR_BLACK FILLCOLOR GRA_CLR_WHITE PATTERN nLoop

  @15, (nLoop * 10), 30, (nLoop * 10) + 10  DCPS FRAME THICKNESS .5 ;
      BORDERCOLOR GRA_CLR_DARKRED FILLCOLOR GRA_CLR_DARKBLUE PATTERN nLoop

  @30, (nLoop * 10), 45, (nLoop * 10) + 10  DCPS FRAME THICKNESS .5 ;
      BORDERCOLOR GRA_CLR_DARKGREEN FILLCOLOR GRA_CLR_YELLOW PATTERN nLoop

NEXT nLoop

@ 48, 0, 63, 25 DCPS ELLIPSE THICKNESS 1 BORDERCOLOR GRA_CLR_BLACK  ;
                     FILLCOLOR GRA_CLR_CYAN PATTERN APS_VERTICAL

DCPS ENDDOC

RETURN nil
